unit GetLyrics;

interface

uses
  ANekoAudio,
  Classes, SYSUtils;

///////////////////////////////////////////////////////////////////////////

  function URL_DarkLyricsCom(AFileInfo: TAudioFileInfo): String;
  function URL_Sing365Com(AFileInfo: TAudioFileInfo): String;

///////////////////////////////////////////////////////////////////////////
implementation

uses StrUtils;
///////////////////////////////////////////////////////////////////////////

const

  CR = #13;
  LF = #10;
  CRLF = CR+LF;
  CRLF2 = CRLF+CRLF;

  URI_CHAR = [Char(0)..Char($FF)];
  URI_LALPHA = [ 'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
    'p','q','r','s','t','u','v','w','x','y','z' ];
  URI_UALPHA = [ 'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
    'P','Q','R','S','T','U','V','W','X','Y','Z' ];
  URI_DIGIT = [ '0','1','2','3','4','5','6','7','8','9'  ];
  URI_MARK = [ '-','_','.','!','~','*','''','(',')'  ];
  URI_ALPHA = URI_LALPHA + URI_UALPHA;
  URI_ALPHANUM = URI_ALPHA + URI_DIGIT;
  URI_RESERVED = [ ';','/','?',':','@','&','=','+','$',',' ];
  URI_UNRESERVED = URI_MARK + URI_ALPHANUM;
  URI_HEX = URI_DIGIT + [ 'a','b','c','d','e','f','A','B','C','D','E','F' ];

  URI_DOESCAPE = URI_CHAR - URI_UNRESERVED + ['~'];
  HEXSTR = '0123456789ABCDEF';
  HEXSTRA : Array[0..15]of Char =
    ('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f');

///////////////////////////////////////////////////////////////////////////

  function EncStr(S: String): String;
  var
    i : Integer;
  begin
    Result := '';
    for i:=1 to Length(S) do
    begin
      if S[i] in URI_DOESCAPE then
        Result := Result + '%' + IntToHex(Byte(S[i]),2)
      else
        Result := Result + S[i];
    end;
  end;

  function RmSpc(S: String): String;
  begin
    Result := AnsiReplaceStr(S,' ','');
  end;
  function OnlyAlphaNum(S: String): String;
  var
    i : Integer;
  begin
    Result := '';
    S := LowerCase(S);
    for i:=1 to Length(S) do
      if S[i] in ['0'..'9','a'..'z','.'] then
        Result := Result+S[i];
  end;
  function Ini(S: String): String;
  begin
    Result := LowerCase(Copy(S,1,1));
  end;

  function LowC(S: String): String;
  begin
    Result := LowerCase(S);
  end;

  ///////////////////////////////////////////////////////////////////////////
  {Get URL}
  ///////////////////////////////////////////////////////////////////////////
  function URL_DarkLyricsCom(AFileInfo: TAudioFileInfo): String;
  begin
    with AFileInfo do
      Result :=
        'http://darklyrics.com/lyrics/'+
        OnlyAlphaNum(Artist)+
        '/'+
        OnlyAlphaNum(Album)+
        '.html';
  end;
  function URL_Sing365Com(AFileInfo: TAudioFileInfo): String;
  begin
    with AFileInfo do
      Result :=
        'http://search.sing365.com/search.php?searchstr='+
        EncStr(Artist)+
        '&category=artist&x=0&y=0';
  end;


end.
