{
    MP3Player - Free Delphi Component
    Copyright (C) 1999  Kei Ishida

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
{
    Hacked By AkumaNekoShogun , 2005 (DEFINE ANEKOS)
}
//{$define UseReadAhead}
{$define ASM_X86}
{$DEFINE ANEKOS}

unit MP3Plyr;

interface

uses
  RTLConsts,
  Windows, Messages, SysUtils, Classes, Forms, MMSystem, MP3Trds, MP3Decdr;

const
  //  Decode ̓o͗pobt@̃oCg
  InBufSize = 64*1024;
  OutBufSize = 5*1024;

  //  Xg[ǂގ̃oCg
  DefaultReadLen = InBufSize div 4;

  //  t@CsǍ݃obt@̃oCg
  ReadAheadBufSize = 256*1024;

  //  PCM foCX̏o͂ŉ~b̃obt@mۂ邩
  PCMOutBufTimeLen = 2000;

  //  PCM foCX̏o͂Ńobt@邩
  PCMOutBufCount = 4;

  //
  MaxFrameBytes = 1441;

  //  wb_TAoCg܂ŒT
  MaxRetryBytes = 4096;

  //  for main thread message
  MPM_CHANGEPOSITION = WM_USER+10;
  MPM_DECODEERROR = WM_USER+11;
  MPM_DECODEEND = WM_USER+12;
  MPM_PCMOUTHASROOM = WM_USER+13;
  MPM_CHANGESTATUS = WM_USER+14;
  MPM_ENDPLAY = WM_USER+15;
  MPM_CHANGEEQUALIZER = WM_USER+16;

  //  for pcm out thread message
  MPM_WAVEFILEWRITE = WM_USER+20;

  //   for TMPLoopThread class message
  MPM_TERMINATETHREAD = WM_USER+30;
  MPM_WATCHEVENT = WM_USER+31;
  MPM_SYNCTHREAD = WM_USER+32;
  MPM_TIMEOUTTHREAD = WM_USER+33;

  MPM_FIRST = WM_USER;
  MPM_LAST = WM_USER+39;

type
  EMP3Error = Exception;

  TMPEvent = class(TObject)
  private
    FHandle: THandle;
  protected
  public
    constructor Create(
      EventAttributes: PSecurityAttributes = nil;
      ManualReset: Boolean = True;
      InitialState: Boolean = False;
      const Name: string = ''
    );
    destructor Destroy; override;

    procedure SetEvent;
    procedure ResetEvent;
    function WaitFor(TimeOut: LongWord): LongWord;

    property Handle: THandle read FHandle;
  end;

  TMPSimpleEvent = class(TMPEvent)
  end;

  TMPLoopThreadErrorEvent = procedure(Sender: TObject; E: Exception;
    var Handled: Boolean) of object;

  
  TMPLoopThread = class(TObject)
  private
    FThreadID: DWORD;
    FHandle: THandle;

    FOnThreadError: TMPLoopThreadErrorEvent;

    FWatchEvent: TMPEvent;
    FParent: TObject;
    FTimeOut: DWord;

    function GetPriority: Integer;
    procedure SetPriority(const Value: Integer);
    function GetTerminated: Boolean;
  protected
    procedure Execute;
  public
    constructor Create(Parent: TObject);
    destructor Destroy; override;

    procedure Resume;
    procedure Suspend;
    procedure PostMessage(Msg: UINT; wParam: WPARAM; lParam: LPARAM);
    procedure WaitForProcessMessages;
    procedure WaitForTerminate;
    procedure Terminate;

    property Terminated: Boolean read GetTerminated;
    property Handle: THandle read FHandle;
    property ThreadID: DWORD read FThreadID;
    property Priority: Integer read GetPriority write SetPriority;
    property WatchEvent: TMPEvent read FWatchEvent;
    property OnThreadError: TMPLoopThreadErrorEvent
      read FOnThreadError write FOnThreadError;
    property TimeOut: DWord read FTimeOut write FTimeOut;
  end;

  //  Stream Ǎ⏕NX
  TMPStreamReader = class(TObject)
  private
    FStream: TStream;
    FSize: Integer;
    FSeekable: Boolean;

    FIsOpen: Boolean;
    FBufTop: PChar;        //  zobt@
    FBufDataBegin: Integer; //  zobt@̃f[^ŏ
    FBufDataLen: Integer;   //  zobt@̃f[^̃oCg
    FBufSize: Integer;
    FPosition: Integer;
    FAvailableBytes: Integer;

    procedure BufBeginToTop;
    function  GetBuffer: PChar;
    function FillOnly(Count: Integer): Boolean;
  protected
  public
    // BufSize ͓ǍɎgobt@TCY
    constructor Create(BufSize: Integer);

    destructor Destroy; override;

    //  Stream ̓ǍJn
    //    Stream ͓Ǎ\łȂĂ͂ȂȂ
    //    Stream.Seek \bhg邩ǂ Seekable Ŏw
    //    Seekable  Stream w肷ꍇÃ\bhĂԑO Stream 
    //    擪 Seek Ă
    //    Close \bhĂԂ܂ Stream 𒼐ڑ Free Ă͂Ȃ
    procedure Open(Stream: TStream; Seekable: Boolean);

    //  Open ŊJnǍI
    procedure Close;

    //  Eߒl TStream.Seek ƓӖ
    //    Seekable  Stream ƗO
    function Seek(Offset: Longint; Origin: Word): Longint;

    //  Strema ǂݍ Buffer  Count oCg߂
    //    ΁Aߒl True
    //    ΁AAvailableBytes  Count ȏ゠
    //    sAǂݍ߂邾ǂݍ False Ԃ
    //    Count  BufSize ȉɂ邱
    //    Fill ݂͌ Position ς Buffer 𖄂߂
    //    FillTail  Stream ̏I[ Count oCg Buffer 𖄂߂
    function Fill(Count: Integer): Boolean;
    function FillTail(Count: Integer): Boolean;

    //  K fill EEEAꓖIłȁEE
    function  FillOnIdle: Boolean;

    //  Position  Count oCg
    //    ΁Aߒl True
    function Skip(Count: Integer): Boolean;

    //  Stream oCg邩
    //    Seekable  Stream  MaxInt Ԃ
    property Size: Integer read FSize;

    //  Buffer w擪oCg Stream Ő擪牽oCgڂɂ邩
    property Position: Integer read FPosition;

    //  Stream ǂݍ񂾌ʂĂobt@
    //    Ă Stream ɔfȂ
    property Buffer: PChar read GetBuffer;

    //  Buffer ŗLȃoCg
    property AvailableBytes: Integer read FAvailableBytes;

    //  obt@̃oCg
    property BufSize: Integer read FBufSize;

    //  Open ̃Xg[V[N\ǂ
    //    Open ȂΕs
    property Seekable: Boolean read FSeekable;
  end;

  TDoneOutputEvent = procedure(Sender: TObject) of object;

  TSoundOut = class(TObject)
  private
    FSamplingRate: Integer;
    FChannels: Integer;
    FBitsPerSample: Integer;
    FIsOpen: Boolean;
    FVolume: Integer;
    FDeviceID: DWord;
    FOnThreadError: TMPLoopThreadErrorEvent;
    FOnDoneOutput: TDoneOutputEvent;
    FDoneOutputStep: DWord;
    FLastDoneOutput: DWord;

    FWaveOutHandle: HWAVEOUT;
    FWaveOutHeaders: array[0..PCMOutBufCount-1] of TWaveHdr;

    FWaveStream: TFileStream;

    FBufs: array[0..PCMOutBufCount-1] of  PChar;
    FBufIndex: Integer;
    FBufAvailableLen: Integer;
    FUsedBufCount: Integer;
    FBufItemSize: Integer;
    FVolBalance: Integer;

    FWaveOutThread: TMPLoopThread;

    FRequestCS: TMPSimpleMutex;
    FRequestedEvent: TMPEvent;
    FRequestedWindowHandle: THandle;
    FEmptyEvent: TMPEvent;
    FWaveFileName: TFileName;
    FLastTime: LongWord;
    FBufsCS: TMPSimpleMutex;

    procedure SetVolumeToWaveDevice;

    procedure SetBitsPerSample(const Value: Integer);
    procedure SetChannels(const Value: Integer);
    procedure SetSamplingRate(const Value: Integer);
    procedure SetVolume(const Value: Integer);

    class procedure CheckWaveOut(ErrorCode: MMRESULT; Msg: String);
    procedure RequestCheck;
    procedure WaveWrite;
    procedure SetVolBalance(const Value: Integer);
    procedure SetWaveFileName(const Value: TFileName);
    function GetDoneBytes: Integer;
    function GetWaveVolume: Integer;
    function IsEmpty: Boolean;
  protected
    procedure MMWomDone(var Msg: TMessage); message MM_WOM_DONE;
    procedure MPMWaveFileWrite(var Msg: TMessage); message MPM_WAVEFILEWRITE;
    procedure MPMTimeOutThread(var Msg: TMessage); message MPM_TIMEOUTTHREAD;
    procedure ThreadError(Sender: TObject; E: Exception; var Handled: Boolean);
    procedure DoneOutput;
  public
    constructor Create;
    destructor  Destroy; override;

    procedure Open;
    procedure Close;
    procedure Stop;
    procedure Flush;
    procedure Pause;
    procedure Unpause;

    //  o̓obt@ɏ
    //    obt@ɏ񂾃oCgԂ
    function  Write(const Buf; Count: Integer): Integer;

    //  o̓obt@̋󂫂邩ǂ
    //    1oCgł󂫂 True
    function  HasRoom: Boolean;

    //  o̓obt@̋󂫒ʒmv
    procedure RequestEvent(Event: TMPEvent);
    procedure RequestMessage(WindowHandle: THandle);

    //  obt@ɂȂ܂ő҂
    procedure WaitForEmpty;

    //  obt@̋󂫂 100 ŕԂ
    function  BufRoomRate: Integer ;

    //  o̓foCX̖O擾
    class function GetDeviceName(Idx: Integer): String;

    //  o̓foCX̐擾
    class function GetDeviceCount: Integer;

    //  Open ς݂ǂ
    property  IsOpen: Boolean read FIsOpen;

    //  TvO[g(l)
    //    ftHg 44100
    property  SamplingRate: Integer read FSamplingRate write SetSamplingRate;

    //  `l
    //    ͈͂ 1..2
    //    ftHg 2
    property  Channels: Integer read FChannels write SetChannels;

    //  Tṽrbg
    //    ͈͂ 8 or 16
    //    ftHg 16
    property  BitsPerSample: Integer read FBitsPerSample write SetBitsPerSample;

    //  {[
    //    ͈͂ 0..100
    //    t@Co͎͖
    //    ftHg͋ÑTEhhCo̐ݒl
    property  Volume: Integer read FVolume write SetVolume;

    //  {[̍ẼoX
    //    ͈͂ -100..100
    //    ōAŉE
    //    ftHg 0
    property  VolBalance: Integer read FVolBalance write SetVolBalance;

    //  o͂t@C
    //    ݒ肵t@C RIFF/WAVE `ŏo͂
    //    Open \bhOɐݒ肷邱
    //    o͂鎞 '' ɂ邱
    //    ftHg ''
    property  WaveFileName: TFileName read FWaveFileName write SetWaveFileName;

    //  OnDontOutput CxgNpx
    //    ςɂŎw肵ԖɋN
    //    Pʃ~b
    //    ftHg INFINITE
    property DoneOutputStep: DWord read FDoneOutputStep write FDoneOutputStep;

    //  o͂foCXID
    //    ftHg WAVE_MAPPER
    property DeviceID: DWord read FDeviceID write FDeviceID;


    //  o͒̕ʃXbhG[̔ʒmCxg
    //    ʃXbhŌĂ΂
    property OnThreadError: TMPLoopThreadErrorEvent
      read FOnThreadError write FOnThreadError;

    //  o͂If[^邱ƂʒmCxg
    //    ʃXbhŌĂ΂
    property OnDoneOutput: TDoneOutputEvent
      read FOnDoneOutput write FOnDoneOutput;
  end;


  TMP3StreamType = set of (mstSeekable, mstOwn);
  TMP3Status = (mstStop, mstPlay, mstPause);
  TMP3EndPlayReason = (merSuccessful, merStoped, merFailure);
  TMP3EndPlayEvent = procedure(Sender: TObject;
    Reason: TMP3EndPlayReason) of object;
  TMP3InfoType = set of (mitID3V1, mitID3V2, mitRiff, mitMacBin, mitLyrics);
  TMP3Capabilities = set of (mcbCanOpen, mcbCanClose, mcbCanPlay, mcbCanStop,
    mcbCanPause, mcbCanUnpause, mcbCanSeek, mcbCanPlayToFile);
  TMP3CpuCapabilities = set of (mccMMX, mcc3DNow, mccKNI, mccE3DNow, mccCMOV,
    mccEMMX);
  TMP3EqualizerMode = (memSubBand, memFreq);

const
  MccAll = [mccMMX, mcc3DNow, mccKNI, mccE3DNow, mccCMOV, mccEMMX];

type
  //  MP3 t@CǗNX
  //  ȉ̏ŌƉ肵ĂB
  //  EMacBin wb_
  //  ERIFF wb_[
  //  EDATA ȊO RIFF `N
  //  EDATA `Nwb_
  //  EID3TagVer2
  //  E{
  //  Elyrics
  //  ELIST/INFO ȊO RIFF `N
  //  ELIST/INFO `N
  //  EID3TagVer1
  //  EMacBin \[XtH[N
  //  {̈ȊO͑S optionalB
  //  ϐȂǂ̃Rg̒̃ItZbgƂ́ALȂA
  //  Xg[擪̃oCg
  //  {̂̏ Seek \Xg[炵ǂ߂Ȃ
  TMP3Info = class(TObject)
  private
    FReader: TMPStreamReader;
    FFileName: TFileName;
    FInfoType: TMP3InfoType;

    //  {̊֘A
    FBodyPos: Integer;          //  {̂̃ItZbg
                                //  O 0
    FBodyLength: Integer;       //  {̂̃oCg
                                //  O MaxInt

    //  MacBin ֘A
    FMacBinDataPos: Integer;        //  MacBin f[^tH[ÑItZbg
    FMacBinDataLength: Integer;     //  MacBin f[^tH[ÑoCg
    FMacBinResourcePos: Integer;    //  MacBin \[XtH[ÑItZbg
    FMacBinResourceLength: Integer; //  MacBin \[XtH[ÑoCg

    //  RIFF ֘A
    FRIFFDataPos: Integer;    //  RIFF/data `N{̂̃ItZbg
    FRIFFDataLength: Integer; //  RIFF/data `N{̂̃oCg
    FRIFFInfos: TStrings;     //  RIFF/INFO `Ñf[^

    //  ID3V1 ֘A
    FID3V1Infos: TStrings;  //  ID3V1 ̃f[^
    FID3V1Pos: Integer;     //  ID3V1 ̃ItZbg

    //  ID3V2 ֘A
    FID3V2Infos: TStrings;  //  ID3V2 ̃f[^

    //  Lyrics ֘A
    FLyricsInfos: TStrings; //   Lyrics ̃f[^
    FLyricsPos: Integer;    //   Lyrics ւ̃ItZbg
    FNeedInfoType: TMP3InfoType;

    procedure SetReader(Reader: TMPStreamReader);

    function ReadHead: Boolean;
    function ReadTail: Boolean;

    function SkipRIFFChunksTo(const ChunkID: String; const FormType: String = ''): Boolean;
    function ReadMacBinHeader: Boolean;
    function ReadRIFFHeader: Boolean;
    function ReadRIFFDataChunkHeader: Boolean;
    function ReadID3V2Tag: Boolean;
    function QueryBody: Boolean;
    function ReadLyrics: Boolean;
    function ReadRIFFListInfo: Boolean;
    function ReadID3V1Tag: Boolean;
    function ReadMacBinResource: Boolean;

    function GetAlbum: String;
    function GetArtist: String;
    function GetComment: String;
    function GetGenre: String;
    function GetGenreIndex: Integer;
    function GetTitle: String;
    function GetTrack: String;
    function GetYear: String;
    function GetLyrics: String;

    class function MaxLenString(Strs: array of String): String;
    class function IIFStringOrNull(Cond: Boolean; Str: String): String;

    procedure ReadFromFile(FileName: TFileName);

    procedure Clear;
  protected
  public
    constructor Create;
    destructor Destroy; override;

    property FileName: TFileName read FFileName;
    property InfoType: TMP3InfoType read FInfoType;
    property NeedInfoType: TMP3InfoType read FNeedInfoType write FNeedInfoType;

    property Title: String read GetTitle;
    property Artist: String read GetArtist;
    property Album: String read GetAlbum;
    property Year: String read GetYear;
    property Comment: String read GetComment;
    property Genre: String read GetGenre;
    property GenreIndex: Integer read GetGenreIndex;
    property Track: String read GetTrack;

    property RIFFInfos: TStrings read FRIFFInfos;
    property ID3V1Infos: TStrings read FID3V1Infos;
    property ID3V2Infos: TStrings read FID3V2Infos;
    property LyricsInfos: TStrings read FLyricsInfos;
  end;

  TMP3Player = class(TComponent)
  private
    FStream: TStream;
    FStreamType: TMP3StreamType;
    FReader: TMPStreamReader;
{$ifdef UseReadAhead}
    FReadAheadStream: TMPReadAheadStream;
{$endif}
    FFrameBytes: Integer;
    FFirstHeader: TMpegHead;
    FFirstRawHead: DWORD;
    FFramePosList: TThreadList;
    FRetryBytes: Integer;

    FBodyPos: Integer;        //  {̂̃t@C擪 OFFSET
                              //   0 ȂA{̂̑ÓA擪񉹏
                              //  ŏ̃t[̓wb_wĂ邱
    FBodyLength: Integer;      //  {̂̃oCg
                              //  mO MaxInt

    FAutoPlay: Boolean;
    FAutoOpen: Boolean;
    FFileName: TFileName;
    FChangePosStep: Integer;
    FVolBalance: Integer;
    FVolume: Integer;

    FStatus: TMP3Status;

    FInfo: TMP3Info;

    FChannels: Integer;
    FLayer: Integer;
    FVersion: Integer;
    FSamplingRate: Integer;
    FBitRate: Integer;

    FOnChangeStatus: TNotifyEvent;
    FOnChangePosition: TNotifyEvent;

    FOnEndPlay: TMP3EndPlayEvent;
    FEndPlayReason: TMP3EndPlayReason;

    FSoundOut: TSoundOut;
    FOutBuf: PChar;
    FOutBufAvailableLen: Integer;
    FPCMDoneOutBytes: Integer;
    FPosition: Integer;
    FOutFrameBytes: Integer;
    FOutputBytes: Integer;
    FOutputFileName: TFileName;
    FSoundOutMutex: TMPSimpleMutex;

    FNeedInitDecode: Boolean;

    FWindowHandle: THandle;
    FDecodeThread: TMPLoopThread;
    FDecodeCS: TMPSimpleMutex;

    FUsingCpuCapabilities: TMP3CpuCapabilities;

    FEqualizerCount: Integer;
    FEqualizerMode: TMP3EqualizerMode;
    FEqualizer: array[0..31] of Integer;
    FEqualizerFreq: array[0..31] of Integer;
    FEqualizerEnabled: Boolean;
    FNoisySeek: Boolean;
    FDecodePriority: TThreadPriority;
    FDeviceID: DWord;

    procedure SetAutoOpen(const Value: Boolean);
    procedure SetAutoPlay(const Value: Boolean);
    procedure SetFileName(const Value: TFileName);
    procedure SetStatus(Value: TMP3Status);
    function  GetLength: integer;
    function  GetPosition: Integer;
    procedure SetChangePosStep(const Value: Integer);
    procedure SetVolume(const Value: Integer);
    function  GetIsOpen: Boolean;
    procedure SetVolBalance(const Value: Integer);
    function  GetCapabilities: TMP3Capabilities;
    function GetDeviceCount: Integer;
    function GetDeviceNames(Idx: Integer): String;
    procedure SetDeviceID(const Value: DWord);

    procedure WndProc(var Message: Tmessage);
    procedure PostMessage(Msg: UINT; wParam: WPARAM; lParam: LPARAM);
    procedure PostUniqMessage(Msg: UINT; wParam: WPARAM; lParam: LPARAM);
    procedure RemoveMessages(MsgFilterMin, MsgFilterMax: UINT);

    procedure ResetDecode;
    function  GetFrameBytes(var Buf; var H: TMpegHead): Integer;
    function  InitLMC(var h: TMpegHead; framebytes_arg: Integer;
     reduction_code: Integer; transform_code: Integer; convert_code: Integer;
     freq_limit: Integer): Integer;
    function  IsValidRawHeader(RawH: TMpegRawHead): Boolean;
    procedure ReadVBRHeader;
    procedure UpdatePosition;
    procedure SetDecodePriority(const Value: TThreadPriority);

    procedure ThreadError(Sender: TObject; E: Exception; var Handled: Boolean);
    procedure PCMDoneOutput(Sender: TObject);

    function GetHasCpuCapabilities: TMP3CpuCapabilities;
    procedure SetUsingCpuCapabilities(const Value: TMP3CpuCapabilities);

    function GetEqualizer(Index: Integer): Integer;
    procedure SetEqualizer(Index: Integer; const Value: Integer);
    procedure SetEqualizerEnabled(const Value: Boolean);
    function GetEqualizerFreq(Index: Integer): Integer;
    procedure SetEqualizerCount(const Value: Integer);
    procedure SetEqualizerFreq(Index: Integer; const Value: Integer);
    procedure SetEqualizerMode(const Value: TMP3EqualizerMode);
    function GetInvertPolarity: Boolean;
    procedure SetInvertPolarity(const Value: Boolean);

    function GetAlbum: String;
    function GetArtist: String;
    function GetComment: String;
    function GetGenre: String;
    function GetGenreIndex: Integer;
    function GetID3V1Infos: TStrings;
    function GetID3V2Infos: TStrings;
    function GetInfoType: TMP3InfoType;
    function GetRIFFInfos: TStrings;
    function GetTitle: String;
    function GetTrack: String;
    function GetYear: String;
    function GetNeedInfoType: TMP3InfoType;
    procedure SetNeedInfoType(const Value: TMP3InfoType);
  protected
    procedure Loaded; override;

    procedure MPMWatchEvent(var Msg: TMessage); message MPM_WATCHEVENT;

    procedure MPMChangePosition(var Msg: TMessage); message MPM_CHANGEPOSITION;
    procedure MPMDecodeError(var Msg: TMessage); message MPM_DECODEERROR;
    procedure MPMDecodeEnd(var Msg: TMessage); message MPM_DECODEEND;
    procedure MPMChangeStatus(var Msg: TMessage); message MPM_CHANGESTATUS;
    procedure MPMEndPlay(var Msg: TMessage); message MPM_ENDPLAY;
    procedure MPMChangeEqualizer(var Msg: TMessage); message MPM_CHANGEEQUALIZER;

    procedure ChangeStatus(Sender: TObject); virtual;
    procedure ChangePosition(Sender: TObject); virtual;
    procedure EndPlay(Sender: TObject); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

    procedure Open;
    procedure OpenStream(Stream: TStream; StreamType: TMP3StreamType);
    procedure Play;
    procedure PlayToFile(FileName: TFileName);
    procedure Stop;
    procedure Pause;
    procedure Unpause;
    procedure Close;
    procedure Seek(NewPosition: Integer);
    procedure SetEqualizerFreqs(MinFreq, MaxFreq: Integer);

    class function QueryOpen(const FileName: TFileName): Boolean;
    class procedure ReadInfo(const FileName: TFileName; Info: TMP3Info);
    class function GetID3Genre(Idx: Byte): String;

    property  Status: TMP3Status read FStatus;
    property  IsOpen: Boolean read GetIsOpen;
    property  Capabilities: TMP3Capabilities read GetCapabilities;

    property Title: String read GetTitle;
    property Artist: String read GetArtist;
    property Album: String read GetAlbum;
    property Year: String read GetYear;
    property Comment: String read GetComment;
    property Genre: String read GetGenre;
    property GenreIndex: Integer read GetGenreIndex;
    property Track: String read GetTrack;
    property RIFFInfos: TStrings read GetRIFFInfos;
    property ID3V1Infos: TStrings read GetID3V1Infos;
    property ID3V2Infos: TStrings read GetID3V2Infos;
    property InfoType: TMP3InfoType read GetInfoType;

    property BitRate: Integer read FBitRate;
    property Channels: Integer read FChannels;
    property SamplingRate: Integer read FSamplingRate;
    property Layer: Integer read FLayer;
    property Version: Integer read FVersion;

    property Position: Integer read GetPosition;
    property Length: Integer read GetLength;
    property Equalizer[Index: Integer]: Integer read GetEqualizer write SetEqualizer;
    property HasCpuCapabilities: TMP3CpuCapabilities read GetHasCpuCapabilities;
    property EqualizerFreq[Index: Integer]: Integer
      read GetEqualizerFreq write SetEqualizerFreq;
    property DeviceID: DWord read FDeviceID write SetDeviceID;
    property DeviceNames[Idx: Integer]: String read GetDeviceNames;
    property DeviceCount: Integer read GetDeviceCount;
  published
    property AutoOpen: Boolean read FAutoOpen write SetAutoOpen;
    property AutoPlay: Boolean read FAutoPlay write SetAutoPlay;
    property ChangePosStep: Integer read FChangePosStep write SetChangePosStep;
    property DecodePriority: TThreadPriority read FDecodePriority write SetDecodePriority;
    property EqualizerEnabled: Boolean read FEqualizerEnabled write SetEqualizerEnabled;
    property EqualizerCount: Integer read FEqualizerCount write SetEqualizerCount;
    property EqualizerMode: TMP3EqualizerMode read FEqualizerMode write SetEqualizerMode;
    property FileName: TFileName read FFileName write SetFileName;
    property NeedInfoType: TMP3InfoType read GetNeedInfoType write SetNeedInfoType;
    property NoisySeek: Boolean read FNoisySeek write FNoisySeek;
    property InvertPolarity: Boolean
      read GetInvertPolarity write SetInvertPolarity;
    property UsingCpuCapabilities: TMP3CpuCapabilities
      read FUsingCpuCapabilities write SetUsingCpuCapabilities;
    property VolBalance: Integer read FVolBalance write SetVolBalance;
    property Volume: Integer read FVolume write SetVolume;

    property OnChangePosition: TNotifyEvent
      read FOnChangePosition write FOnChangePosition;
    property OnChangeStatus: TNotifyEvent
      read FOnChangeStatus write FOnChangeStatus;
    property OnEndPlay: TMP3EndPlayEvent read FOnEndPlay write FOnEndPlay;
  end;


const
  GenreTbl: array[Byte] of String = (
    'Blues',
    'Classic Rock',
    'Country',
    'Dance',
    'Disco',
    'Funk',
    'Grunge',
    'Hip-Hop',
    'Jazz',
    'Metal',
    'New Age',
    'Oldies',
    'Other',
    'Pop',
    'R&B',
    'Rap',
    'Reggae',
    'Rock',
    'Techno',
    'Industrial',
    'Alternative',
    'Ska',
    'Death Metal',
    'Pranks',
    'Soundtrack',
    'Euro-Techno',
    'Ambient',
    'Trip-Hop',
    'Vocal',
    'Jazz+Funk',
    'Fusion',
    'Trance',
    'Classical',
    'Instrumental',
    'Acid',
    'House',
    'Game',
    'Sound Clip',
    'Gospel',
    'Noise',
    'AlternRock',
    'Bass',
    'Soul',
    'Punk',
    'Space',
    'Meditative',
    'Instrumental Pop',
    'Instrumental Rock',
    'Ethnic',
    'Gothic',
    'Darkwave',
    'Techno-Industrial',
    'Electronic',
    'Pop-Folk',
    'Eurodance',
    'Dream',
    'Southern Rock',
    'Comedy',
    'Cult',
    'Gangsta',
    'Top 40',
    'Christian Rap',
    'Pop/Funk',
    'Jungle',
    'Native American',
    'Cabaret',
    'New Wave',
    'Psychadelic',
    'Rave',
    'Showtunes',
    'Trailer',
    'Lo-Fi',
    'Tribal',
    'Acid Punk',
    'Acid Jazz',
    'Polka',
    'Retro',
    'Musical',
    'Rock & Roll',
    'Hard Rock',
    'Folk',
    'Folk/Rock',
    'National Folk',
    'Swing',
    'Fast Fusion',
    'Bebob',
    'Latin',
    'Revival',
    'Celtic',
    'Bluegrass',
    'Avantgarde',
    'Gothic Rock',
    'Progressive Rock',
    'Psychedelic Rock',
    'Symphonic Rock',
    'Slow Rock',
    'Big Band',
    'Chorus',
    'Easy Listening',
    'Acoustic',
    'Humour',
    'Speech',
    'Chanson',
    'Opera',
    'Chamber Music',
    'Sonata',
    'Symphony',
    'Booty Bass',
    'Primus',
    'Porn Groove',
    'Satire',
    'Slow Jam',
    'Club',
    'Tango',
    'Samba',
    'Folklore',
    'Ballad',
    'Power Ballad',
    'Rhysmic Soul',
    'Freestyle',
    'Duet',
    'Punk Rock',
    'Drum Solo',
    'Acapella',
    'Euro-House',
    'Dance-Hall',
    'Goa',
    'Drum & Bass',
    'Hardcore',
    'Club-House',
    'Terror',
    'Indie',
    'BritPop',
    'Negerpunk',
    'Polsk Punk',
    'Beat',
    'Christian Gangsta Rap',
    'Heavy Metal',
    'Blank Metal',
    'Crossover',
    'Contemporrary Christian',
    'Christian Rock',
    'Merengue',
    'Salsa',
    'Trash Metal',
    'Anime',
    'JPop',
    'Synthpop',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    'Heavy Rock(J)',
    'Doom Rock(J)',
    'J-POP(J)',
    'Seiyu(J)',
    'Tecno Ambient(J)',
    'Moemoe(J)',
    'Tokusatsu(J)',
    'Anime(J)'
  );

{$IFDEF ANEKOS}
  var SamplingRatePer : Integer = 100;
{$ENDIF}


procedure Register;

implementation

uses
  Math, Consts, MPCPUSpc;

resourcestring
  SInvalidMP3Format = 'unknown MPEG Audio format.';
  SUnknownPCMOutAPIError = 'unknown wave out API error.';




procedure Register;
begin
  RegisterComponents('Samples', [TMP3Player]);
end;



{ Helpers }

//  N ͐Ɖ
function  RoundUpToEven(N: Integer): Integer;
begin
  Result := (N+1) div 2 *2;
end;

function  ReadBigEndianInt(var Data): Integer;
var
  pData: PChar;
begin
  pData := PChar(@Data);
  Result := (Integer(pData[0]) shl 24)+
            (Integer(pData[1]) shl 16)+
            (Integer(pData[2]) shl  8)+
            (Integer(pData[3]) shl  0);
end;

function CharArrayToString(Chars: PChar; Size: Integer): String;
begin
  if Size > 0 then begin
    SetLength(Result, Size);
    FillChar(Result[1], Size, 0);
    StrLCopy(PChar(Result), Chars, Size);
    Result := TrimRight(Result);
  end
  else begin
    Result := '';
  end;
end;

function CharArrayToStringFromRight(Chars: PChar; Size: Integer): String;
var
  idx: Integer;
begin
  if Size > 0 then begin
    SetLength(Result, Size);
    FillChar(Result[1], Size, 0);
    idx := Size-1;
    while 0 < idx do begin
      if Chars[idx-1] = #0 then begin
        Break;
      end;
      Dec(idx);
    end;
    StrLCopy(PChar(Result), @(Chars[idx]), Size-idx);
    Result := TrimRight(Result);
  end
  else begin
    Result := '';
  end;
end;

procedure GetMemAlign(var P; Size: Integer; Align: Integer);
var
  origP: Pointer;
  newP: Pointer;
begin
  GetMem(origP, Size+Align+SizeOf(origP)-1);
  newP := Pointer((Integer(origP)+Align+SizeOf(origP)-1) and (not (Align-1)));
  Move(origP, PChar(newP)[-SizeOf(origP)], SizeOf(origP));
  Move(newP, P, SizeOf(newP));
end;

procedure FreeMemAlign(var P);
var
  origP: Pointer;
begin
  Move(PChar(P)[-SizeOf(origP)], origP, SizeOf(origP));
  FreeMem(origP);
end;



{ TMPEvent }

constructor TMPEvent.Create(EventAttributes: PSecurityAttributes;
  ManualReset, InitialState: Boolean; const Name: string);
begin
  inherited Create;

  FHandle := CreateEvent(EventAttributes, ManualReset, InitialState, PChar(Name));

  if FHandle = 0 then begin
    RaiseLastWin32Error;
  end;
end;

destructor TMPEvent.Destroy;
begin
  if FHandle <> 0 then begin
    CloseHandle(FHandle);
  end;

  inherited Destroy;
end;

procedure TMPEvent.ResetEvent;
begin
  Windows.ResetEvent(FHandle);
end;

procedure TMPEvent.SetEvent;
begin
  Windows.SetEvent(FHandle);
end;

function TMPEvent.WaitFor(TimeOut: LongWord): LongWord;
begin
  Result := Windows.WaitForSingleObject(FHandle, TimeOut);
end;

{ TMPLoopThread }

function ThreadProc(Parent: TMPLoopThread): Integer;
begin
  Result := 0;
  try
    Parent.Execute;
  finally
    EndThread(Result);
  end;
end;

constructor TMPLoopThread.Create(Parent: TObject);
begin
  inherited Create;

  FParent := Parent;

  FHandle := BeginThread(nil, 0, @ThreadProc, Self, CREATE_SUSPENDED, FThreadId );

  FWatchEvent := TMPSimpleEvent.Create;

  FTimeOut := INFINITE;
end;

destructor TMPLoopThread.Destroy;
begin
  WaitForTerminate;

  if FHandle <> 0 then begin
    CloseHandle(FHandle);
  end;

  FWatchEvent.Free;

  inherited Destroy;
end;

procedure TMPLoopThread.Execute;
var
  watchHandle: THandle;
  msg: TMsg;
  errorHandled: Boolean;

  procedure HandleMessage(Msg: UINT; WParam, LParam: Integer);
  var
    message: TMessage;
  begin
    if Assigned(FParent) then begin
      FillChar(message, SizeOf(message), 0);
      message.Msg := Msg;
      message.WParam := WParam;
      message.LParam := LParam;
      FParent.Dispatch(message);
    end;
  end;

begin
  watchHandle := FWatchEvent.Handle;
  while True do begin
    try

      case MsgWaitForMultipleObjects(1, watchHandle, False, FTimeOut,
        QS_ALLINPUT) of
        WAIT_OBJECT_0: begin
          HandleMessage(MPM_WATCHEVENT, 0, 0);
        end;
        WAIT_TIMEOUT: begin
          HandleMessage(MPM_TIMEOUTTHREAD, 0, 0);
        end;
      end;
      while PeekMessage(msg, 0, 0, 0, PM_REMOVE) do begin
        case msg.message of
        MPM_TERMINATETHREAD: begin
          Exit;
        end;
        MPM_SYNCTHREAD: begin
          if (msg.wParam <> 0) and (TObject(msg.wParam) is TMPEvent) then begin
            TMPEvent(msg.wParam).SetEvent;
          end;
        end;
        else
          with msg do begin
            HandleMessage(message, wParam, lParam);
          end;
        end;
      end;
    except
      on e: Exception do begin
        errorHandled := False;
        if Assigned(FOnThreadError) then  begin
          FOnThreadError(Self, e, errorHandled);
        end;
        if not errorHandled then begin
          Application.ShowException(e);
        end;
      end;
    end;
  end;
end;

function TMPLoopThread.GetPriority: Integer;
begin
  Result := GetThreadPriority(FHandle);
end;

function TMPLoopThread.GetTerminated: Boolean;
begin
  Result := WaitForSingleObject(FHandle, 0) = WAIT_OBJECT_0;
end;

procedure TMPLoopThread.PostMessage(Msg: UINT; wParam: WPARAM; lParam: LPARAM);
begin
  if FHandle <> 0 then begin
    PostThreadMessage(FThreadID, Msg, wParam, lParam);
  end;
end;

procedure TMPLoopThread.Resume;
begin
  ResumeThread(FHandle);
end;

procedure TMPLoopThread.SetPriority(const Value: Integer);
begin
  SetThreadPriority(FHandle, Value);
end;

procedure TMPLoopThread.Suspend;
begin
  SuspendThread(FHandle);
end;

procedure TMPLoopThread.Terminate;
begin
  PostMessage(MPM_TERMINATETHREAD, 0, 0);
end;

procedure TMPLoopThread.WaitForProcessMessages;
var
  event: TMPEvent;
  handles: array[0..1] of THandle;
begin
  event := TMPSimpleEvent.Create;
  try
    handles[0] := FHandle;
    handles[1] := event.Handle;
    PostMessage(MPM_SYNCTHREAD, DWORD(event), 0);
    WaitForMultipleObjects(2, @handles, False, INFINITE);
  finally
    event.Free;
  end;
end;

procedure TMPLoopThread.WaitForTerminate;
begin
  if FHandle = 0 then begin
    Exit;
  end;

  Terminate;
  WaitForSingleObject(FHandle, INFINITE);
end;


{ TMPStreamReader }

procedure TMPStreamReader.BufBeginToTop;
var
  pHeadBuf: PChar;
  headLen: Integer;
  tailLen: Integer;
begin
  headLen := FBufDataLen;
  tailLen := FBufDataBegin+FBufDataLen-FBufSize;
  if 0 < tailLen then begin
    Dec(headLen, tailLen);
    if tailLen+headLen < FBufDataBegin then begin
      Move(FBufTop[0], FBufTop[headLen], tailLen);
      Move(FBufTop[FBufDataBegin], FBufTop[0], headLen);
    end
    else begin
      pHeadBuf := nil;
      try
        GetMem(pHeadBuf, headLen);
        Move(FBufTop[FBufDataBegin], pHeadBuf[0], headLen);
        Move(FBufTop[0], FBufTop[headLen], tailLen);
        Move(pHeadBuf[0], FBufTop[0], headLen);
      finally
        if pHeadBuf <> nil then begin
          FreeMem(pHeadBuf);
        end;
      end;
    end;
  end
  else begin
    Move(FBufTop[FBufDataBegin], FBufTop[0], headLen);
  end;
  FBufDataBegin := 0;
  FAvailableBytes := FBufDataLen;
end;

procedure TMPStreamReader.Close;
begin
  if not FIsOpen then begin
    Exit;
  end;

  FStream := nil;
  FAvailableBytes := 0;
  FSize := 0;

  if Assigned(FBufTop) then begin
    FreeMemAlign(FBufTop);
    FBufTop := nil;
  end;

  FIsOpen := False;
end;

constructor TMPStreamReader.Create(BufSize: Integer);
begin
  inherited Create;

  Assert(0 < BufSize);
  FBufSize := BufSize;
end;

destructor TMPStreamReader.Destroy;
begin
  Close;

  inherited Destroy;
end;

function TMPStreamReader.Fill(Count: Integer): Boolean;
begin
  Assert(FStream <> nil);

  Result := False;

  if not FillOnly(Count) then begin
    Exit;
  end;

  if FAvailableBytes < Count then begin
    BufBeginToTop;
  end;

  Assert(Count <= FAvailableBytes);
  Result := True;
end;

function TMPStreamReader.FillOnIdle: Boolean;
var
  readLen: Integer;
begin
  Assert(FStream <> nil);

  Result := False;

  if FBufDataLen = FBufSize then begin
    Exit;
  end;

  readLen := FBufSize-FBufDataLen;
  if DefaultReadLen < readLen then begin
    readLen := DefaultReadLen;
  end;

  Result := FillOnly(FBufDataLen+readLen);
end;


function TMPStreamReader.FillOnly(Count: Integer): Boolean;
var
  readLen: Integer;
  readPos: Integer;
begin
  Result := False;

  Assert(FStream <> nil);
  Assert(0 <= Count);
  Assert(Count <= FBufSize);
  Assert(FBufTop <> nil);

  while FBufDataLen < Count do begin

    if DefaultReadLen <= Count-FBufDataLen then begin
      readLen := Count-FBufDataLen;
    end
    else if DefaultReadLen <= FBufSize-FBufDataLen then begin
      readLen := DefaultReadLen;
    end
    else begin
      readLen := FBufSize-FBufDataLen;
    end;

    readPos := (FBufDataBegin+FBufDataLen) mod FBufSize;
    if FBufSize < readPos+readLen then begin
      readLen := FBufSize-readPos;
    end;

    readLen := FStream.Read(FBufTop[readPos], readLen);
    if readLen = 0 then begin
      break;
    end;

    Inc(FBufDataLen, readLen);
  end;

  if FBufSize < FBufDataBegin+FBufDataLen then begin
    FAvailableBytes := FBufSize-FBufDataBegin;
  end
  else begin
    FAvailableBytes := FBufDataLen;
  end;

  Result := Count <= FBufDataLen;
end;

function TMPStreamReader.FillTail(Count: Integer): Boolean;
begin
  Result := False;

  Assert(FStream <> nil);
  Assert(0 <= Count);
  Assert(Count <= FBufSize);
  Assert(FBufTop <> nil);

  if FSeekable then begin
    Seek(-Count, soFromEnd);
    Result := Fill(Count);
  end
  else begin
    while FillOnly(FBufSize) do begin
      Skip(FBufSize-Count+1);
    end;

    if Fill(Count) then begin
      Result := Skip(FAvailableBytes-Count);
    end;
  end;
end;


function  TMPStreamReader.GetBuffer: PChar;
begin
  Result := @(FBufTop[FBufDataBegin]);
end;


procedure TMPStreamReader.Open(Stream: TStream; Seekable: Boolean);
begin
  Assert(Stream <> nil);

  Close;

  FIsOpen := True;

  try
    FStream := Stream;
    FSeekable := Seekable;
    FPosition := 0;
    FAvailableBytes := 0;
    FBufDataBegin := 0;
    FBufDataLen := 0;
    GetMemAlign(FBufTop, FBufSize, 8);
    if FSeekable then begin
      FSize := FStream.Size;
    end;
  except
    Close;
    raise;
  end;
end;

function TMPStreamReader.Seek(Offset: Integer; Origin: Word): Longint;
begin
  Assert(FStream <> nil);
  Assert(FSeekable);

  if Origin = soFromCurrent then begin
    FPosition := FStream.Seek(Offset-FAvailableBytes, Origin);
  end
  else begin
    FPosition := FStream.Seek(Offset, Origin);
  end;
  Result := FPosition;
  FBufDataBegin := 0;
  FBufDataLen := 0;
  FAvailableBytes := 0;
end;

function TMPStreamReader.Skip(Count: Integer): Boolean;
begin
  Result := False;

  Assert(FStream <> nil);
  Assert(0 <= Count);

  if Count <= FBufDataLen then begin
    Dec(FBufDataLen, Count);
    FBufDataBegin := (FBufDataBegin+Count) mod FBufSize;
    Inc(FPosition, Count);
    Result := True;
  end
  else begin
    if FSeekable then begin
      if FPosition+Count <= FSize then begin
        Seek(Count, soFromCurrent);
        Result := True;
      end
      else begin
        Seek(0, soFromEnd);
      end;
    end
    else begin
      while FillOnly(1) do begin

        FillOnly(FBufSize);
        if Count <= FBufDataLen then begin
          Result := Skip(Count);
          Break;
        end;

        //  Skip(FAvailableBytes);
        Inc(FPosition, FBufDataLen);
        FBufDataLen := 0;
        FBufDataBegin := 0;
      end;
    end;
  end;
end;

{ TSoundOut }

function TSoundOut.BufRoomRate: Integer;
begin
  Result := 0;
  if IsOpen then begin
    Result := ((PCMOutBufCount-FUsedBufCount-1)*FBufItemSize+
      (FBufItemSize-FBufAvailableLen))*100 div (FBufItemSize*PCMOutBufCount);
  end;
end;

class procedure TSoundOut.CheckWaveOut(ErrorCode: MMRESULT; Msg: String);
var
  errorMsgBuf: array[0..MAXERRORLENGTH] of Char;
begin
  if ErrorCode <> MMSYSERR_NOERROR then begin
    if MMSystem.WaveOutGetErrorText(ErrorCode, errorMsgBuf, MAXERRORLENGTH) =
      MMSYSERR_NOERROR then begin
      raise EMP3Error.CreateFmt('%s(%s)', [errorMsgBuf, Msg]);
    end
    else begin
      raise EMP3Error.CreateFmt('%s(%s)', [SUnknownPCMOutAPIError, Msg]);
    end;
  end;
end;

type
  TWaveHeader = packed record
    MainChunk: array[0..3] of Char;
    FileSize: Integer;
    FormType: array[0..3] of Char;
    SubChunk: array[0..3] of Char;
    ChunkLen: Integer;
    Format: SmallInt;
    Modus: SmallInt;
    SampleRate: Integer;
    BitRate: Integer;
    BlockSize: SmallInt;
    SampleDepth: SmallInt;
    DataChunk: array[0..3] of Char;
    DataSize: Integer;
  end;

procedure TSoundOut.Close;
var
  bufIdx: Integer;

  procedure CloseDevice;
  var
    bufIdx: Integer;
  begin
    FWaveOutThread.TimeOut := INFINITE;

    Flush;

    WaitForEmpty;

    for bufIdx := 0 to PCMOutBufCount-1 do begin
      if FBufs[bufIdx] <> nil then begin
        while MMSystem.WaveOutUnprepareHeader(FWaveOutHandle, @(FWaveOutHeaders[bufIdx]),
          SizeOf(FWaveOutHeaders[bufIdx])) = WAVERR_STILLPLAYING do begin
          Sleep(100);
        end;
      end;
    end;

    if FWaveOutHandle <> 0 then begin
      MMSystem.WaveOutClose(FWaveOutHandle);
      FWaveOutHandle := 0;
    end;
  end;

  procedure CloseFile;
  var
    fileSize: Integer;
    dataSize: Integer;
  begin
    try
      fileSize := FWaveStream.Position-8;
      dataSize := FWaveStream.Position-SizeOf(TWaveHeader);

      FWaveStream.Seek(4, soFromBeginning);
      FWaveStream.WriteBuffer(fileSize, SizeOf(fileSize));

      FWaveStream.Seek(SizeOf(TWaveHeader)-SizeOf(dataSize), soFromBeginning);
      FWaveStream.WriteBuffer(dataSize, SizeOf(dataSize));
    finally
      FWaveStream.Free;
      FWaveStream := nil;
    end;
  end;

begin
  if not IsOpen then begin
    Exit;
  end;

  FRequestedEvent := nil;
  FRequestedWindowHandle := 0;

  try
    if Assigned(FWaveStream) then begin
      CloseFile;
    end;

    if FWaveOutHandle <> 0 then begin
      CloseDevice;
    end;
  finally
    for bufIdx := 0 to PCMOutBufCount-1 do begin
      if FBufs[bufIdx] <> nil then begin
        FreeMem(FBufs[bufIdx]);
        FBufs[bufIdx] := nil;
      end;
    end;
    FIsOpen := False;
  end;
end;

constructor TSoundOut.Create;
begin
  inherited Create;

  FSamplingRate := 44100;
  FChannels := 2;
  FBitsPerSample := 16;
  FDeviceID := WAVE_MAPPER;

  FDoneOutputStep := INFINITE;

  FRequestCS := TMPSimpleMutex.Create;
  FEmptyEvent := TMPSimpleEvent.Create;
  FBufsCS := TMPSimpleMutex.Create;

  FVolume := GetWaveVolume;

  FWaveOutThread := TMPLoopThread.Create(Self);
  with FWaveOutThread do begin
    OnThreadError := Self.ThreadError;
    Resume;
  end;
end;

destructor TSoundOut.Destroy;
begin
  Close;

  FRequestCS.Free;
  FEmptyEvent.Free;
  FBufsCS.Free;

  FWaveOutThread.Free;
  inherited Destroy;
end;

procedure TSoundOut.DoneOutput;
var
  currentTickCount: DWord;
begin
  if Assigned(FOnDoneOutput) and (FDoneOutputStep <> INFINITE) then begin
    currentTickCount := GetTickCount;
    if FDoneOutputStep < currentTickCount-FLastDoneOutput then begin
      FOnDoneOutput(Self);
      FLastDoneOutput := currentTickCount;
    end;
  end;
end;

procedure TSoundOut.Flush;
begin
  if not IsOpen then begin
    Exit;
  end;

  if 0 < FBufAvailableLen then begin
    WaveWrite;

    FWaveOutThread.WaitForProcessMessages;
  end;
end;

class function TSoundOut.GetDeviceCount: Integer;
begin
  Result := waveOutGetNumDevs;
end;

class function TSoundOut.GetDeviceName(Idx: Integer): String;
var
  caps: TWaveOutCaps;
begin
  CheckWaveOut(waveOutGetDevCaps(Idx, @caps, SizeOf(caps)),
    'TSoundOut.GetDeviceNames');
  Result := caps.szPname;
end;

function TSoundOut.GetDoneBytes: Integer;
var
  wroteBytes: LongWord;
  info: TMMTime;
begin
  if IsOpen then begin
    if not Assigned(FWaveStream) then begin
      info.wType := TIME_BYTES;
      CheckWaveOut(waveOutGetPosition(FWaveOutHandle, @info, SizeOf(info)),
        'TSoundOut.GetDoneBytes');
      wroteBytes := info.cb;
    end
    else begin
      wroteBytes := FWaveStream.Position-SizeOf(TWaveHeader);
    end;
    Result := wroteBytes-FLastTime;
    FLastTime := wroteBytes;
  end
  else begin
    Result := 0;
  end;
end;

function TSoundOut.GetWaveVolume: Integer;
var
  waveFormat: TWaveFormatEx;
  curVol: DWORD;
  waveHandle: THandle;
begin
  Result := 100;

  try
    FillChar(waveFormat, SizeOf(waveFormat), 0);
    with waveFormat do begin
      wFormatTag := WAVE_FORMAT_PCM;
      nChannels := FChannels;
      nSamplesPerSec := FSamplingRate;
      wBitsPerSample := FBitsPerSample;
      nBlockAlign := FChannels*FBitsPerSample div 8;
      nAvgBytesPerSec := nBlockAlign*FSamplingRate;
      cbSize := 0;
    end;

    if MMSystem.WaveOutOpen(@waveHandle, FDeviceID, @waveFormat,
      0, 0, CALLBACK_NULL or WAVE_ALLOWSYNC) = MMSYSERR_NOERROR then begin
      try
        CheckWaveOut(MMSystem.waveOutGetVolume(waveHandle, @curVol), 
          'TSoundOut.GetWaveVolume');
      finally
        MMSystem.WaveOutClose(waveHandle);
      end;
    end
    else begin
      if 0 < MMSystem.waveOutGetNumDevs then begin
        CheckWaveOut(MMSystem.waveOutGetVolume(0, @curVol), 
          'TSoundOut.GetWaveVolume');
      end
      else begin
        Exit;
      end;
    end;

    if HiWord(curVol) <= LoWord(curVol) then begin
      Result := (LoWord(curVol)*100+32767) div 65535;
    end
    else begin
      Result := (HiWord(curVol)*100+32767) div 65535;
    end;
  except
    on EMP3Error do begin
    end;
  end;
end;


function TSoundOut.HasRoom: Boolean;
begin
  FBufsCS.Lock;
  try
    Result := ((FUsedBufCount < PCMOutBufCount) and
      (FBufAvailableLen < FBufItemSize));
  finally
    FBufsCS.Unlock;
  end;
end;


function  TSoundOut.IsEmpty: Boolean;
var
  handles: array[0..1] of THandle;
begin
  Result := True;
  if Assigned(FEmptyEvent) and Assigned(FWaveOutThread) then begin
    handles[0] := FEmptyEvent.Handle;
    handles[1] := FWaveOutThread.Handle;

    Result := WaitForMultipleObjects(2, @handles, False, 0) <> WAIT_TIMEOUT;
  end;
end;


procedure TSoundOut.MMWomDone(var Msg: TMessage);
begin
  if InterlockedDecrement(FUsedBufCount) <= 0 then begin
    FEmptyEvent.SetEvent;
    FWaveOutThread.TimeOut := INFINITE;
  end
  else begin
    FWaveOutThread.TimeOut := FDoneOutputStep;
;
  end;

  Assert(0 <= FUsedBufCount);

  RequestCheck;

  if not Assigned(FWaveStream) then begin
    DoneOutput;
  end;
end;

procedure TSoundOut.MPMTimeOutThread(var Msg: TMessage);
begin
  if not Assigned(FWaveStream) then begin
    DoneOutput;
  end;
end;

procedure TSoundOut.MPMWaveFileWrite(var Msg: TMessage);
var
  doneMsg: TMessage;
begin
  Assert(Assigned(FWaveStream));

  with FWaveOutHeaders[Msg.LParam] do begin
    FWaveStream.WriteBuffer(lpData[0], dwBufferLength);
    DoneOutput;
  end;

  FillChar(doneMsg, SizeOf(doneMsg), 0);
  doneMsg.Msg := MM_WOM_DONE;
  doneMsg.LParam := DWORD(@(FWaveOutHeaders[Msg.LParam]));
  MMWomDone(doneMsg);
end;


procedure TSoundOut.Open;

  procedure AllocateBuf;
  var
    bufIdx: Integer;
  begin
    FBufItemSize := (((int64(FChannels)*(FBitsPerSample div 8)*FSamplingRate*PCMOutBufTimeLen div 1000 div PCMOutBufCount)+3) div 4)*4;
    for bufIdx := 0 to PCMOutBufCount-1 do begin
      GetMem(FBufs[bufIdx], FBufItemSize);
      FillChar(FWaveOutHeaders[bufIdx], SizeOf(FWaveOutHeaders[bufIdx]), 0);
      with FWaveOutHeaders[bufIdx] do begin
        lpData := FBufs[bufIdx];
        dwBufferLength := FBufItemSize;
      end;
    end;
  end;

  procedure DeviceOpen;
  var
    bufIdx: Integer;
    waveFormat: TWaveFormatEx;
  begin
    FLastTime := 0;

    FillChar(waveFormat, SizeOf(waveFormat), 0);
    with waveFormat do begin
      wFormatTag := WAVE_FORMAT_PCM;
      nChannels := FChannels;
      nSamplesPerSec := FSamplingRate{$IFDEF ANEKOS}*SamplingRatePer div 100{$ENDIF};
      wBitsPerSample := FBitsPerSample;
      nBlockAlign := FChannels*FBitsPerSample div 8;
      nAvgBytesPerSec := nBlockAlign*FSamplingRate;
      cbSize := 0;
    end;

    CheckWaveOut(MMSystem.WaveOutOpen(@FWaveOutHandle, FDeviceID, @waveFormat,
      DWORD(FWaveOutThread.ThreadID), 0, CALLBACK_THREAD or WAVE_ALLOWSYNC),
      'TSoundOut.Open:WaveOutOpen');

    SetVolumeToWaveDevice;

    AllocateBuf;

    for bufIdx := 0 to PCMOutBufCount-1 do begin
      CheckWaveOut(MMSystem.WaveOutPrepareHeader(FWaveOutHandle, @(FWaveOutHeaders[bufIdx]),
        SizeOf(FWaveOutHeaders[bufIdx])),
        'TSoundOut.Open:WaveOutPreperHeader');
    end;

    FWaveOutThread.TimeOut := FDoneOutputStep;
  end;

  procedure FileOpen;
  var
    waveHeader: TWaveHeader;
  begin
    FLastTime := 0;

    FWaveStream := TFileStream.Create(FWaveFileName, fmCreate);

    with waveHeader do begin
      StrLCopy(MainChunk, 'RIFF', 4);
      FileSize := 0;
      StrLCopy(FormType, 'WAVE', 4);
      StrLCopy(SubChunk, 'fmt ', 4);
      ChunkLen := 16;
      Format := 1;
      Modus := FChannels;
      SampleRate := FSamplingRate;
      BlockSize := FChannels*FBitsPerSample div 8;
      BitRate := BlockSize*FSamplingRate;
      SampleDepth := FBitsPerSample;
      StrLCopy(DataChunk, 'data', 4);
      DataSize := 0;
    end;

    FWaveStream.WriteBuffer(waveHeader, SizeOf(waveHeader));

    AllocateBuf;
   end;

begin
  if IsOpen then begin
    Exit;
  end;

  FIsOpen := True;
  try
    if FWaveFileName = '' then begin
      DeviceOpen;
    end
    else begin
      FileOpen;
    end;
    FBufIndex := 0;
    FBufAvailableLen := 0;
    FUsedBufCount := 0;
    FLastDoneOutput := GetTickCount;
    FEmptyEvent.SetEvent;
  except
    Close;
    raise;
  end;
end;


procedure TSoundOut.Pause;
begin
  if IsOpen and not Assigned(FWaveStream) then begin
    CheckWaveOut(MMSystem.WaveOutPause(FWaveOutHandle),
      'TSoundOut.Pause');
  end;
end;

procedure TSoundOut.RequestCheck;
begin
  if (FRequestedEvent <> nil) or (FRequestedWindowHandle <> 0) then begin
    if HasRoom then begin
      FRequestCS.Lock;
      try
        if FRequestedEvent <> nil then begin
          FRequestedEvent.SetEvent;
          FRequestedEvent := nil;
        end;
        if FRequestedWindowHandle <> 0 then begin
          Windows.PostMessage(FRequestedWindowHandle, MPM_PCMOUTHASROOM, 0, 0);
          FRequestedWindowHandle := 0;
        end;
      finally
        FRequestCS.Unlock;
      end;
    end;
  end;
end;

procedure TSoundOut.RequestEvent(Event: TMPEvent);
begin
  FRequestCS.Lock;
  try
    FRequestedEvent := Event;
  finally
    FRequestCS.Unlock;
  end;

  RequestCheck;
end;

procedure TSoundOut.RequestMessage(WindowHandle: THandle);
begin
  FRequestCS.Lock;
  try
    FRequestedWindowHandle := WindowHandle;
  finally
    FRequestCS.Unlock;
  end;

  RequestCheck;
end;

procedure TSoundOut.SetBitsPerSample(const Value: Integer);
begin
  if Value in [8,16] then begin
    FBitsPerSample := Value;
  end;
end;

procedure TSoundOut.SetChannels(const Value: Integer);
begin
  if Value in [1,2] then begin
    FChannels := Value;
  end;
end;

procedure TSoundOut.SetSamplingRate(const Value: Integer);
begin
  if 0 < Value then begin
    FSamplingRate := Value;
  end;
end;

procedure TSoundOut.SetVolBalance(const Value: Integer);
begin
  if (-100 <= Value) and (Value <= 100) then begin
    FVolBalance := Value;
    if IsOpen and not Assigned(FWaveStream) then begin
      SetVolumeToWaveDevice;
    end;
  end;
end;

procedure TSoundOut.SetVolume(const Value: Integer);
begin
  if Value in [0..100] then begin
    FVolume := Value;
    if IsOpen and not Assigned(FWaveStream) then begin
      SetVolumeToWaveDevice;
    end;
  end;
end;


procedure TSoundOut.SetVolumeToWaveDevice;
var
  lVol: DWORD;
  rVol: DWORD;
  setVolResult: MMRESULT;
begin
  lVol := (FVolume*65535+50) div 100;
  rVol := lVol;
  case FVolBalance of
    1..100: begin
      lVol := (lVol*Cardinal(100-FVolBalance)+50) div 100;
    end;
    -100..-1: begin
      rVol := (rVol*Cardinal(100+FVolBalance)+50) div 100;
    end;
  end;
  setVolResult := MMSystem.WaveOutSetVolume(FWaveOutHandle, rVol shl 16+lVol);
  if setVolResult <> MMSYSERR_NOTSUPPORTED then begin
    CheckWaveOut(setVolResult, 'TSoundOut.SetVolumeToWaveDevice');
  end;
end;

procedure TSoundOut.SetWaveFileName(const Value: TFileName);
begin
  if not IsOpen then begin
    FWaveFileName := Value;
  end;
end;

procedure TSoundOut.Stop;
begin
  if IsOpen and not Assigned(FWaveStream) then begin
    FBufAvailableLen := 0;
    MMSystem.WaveOutReset(FWaveOutHandle);
    FLastTime := 0;
  end;
end;

procedure TSoundOut.ThreadError(Sender: TObject; E: Exception;
  var Handled: Boolean);
begin
  if Assigned(FOnThreadError) then begin
    FOnThreadError(Self, E, Handled);
  end;
end;

procedure TSoundOut.Unpause;
begin
  if IsOpen and not Assigned(FWaveStream) then begin
    CheckWaveOut(MMSystem.WaveOutRestart(FWaveOutHandle),
      'TSoundOut.Unpause');
  end;
end;

procedure TSoundOut.WaitForEmpty;
var
  handles: array[0..1] of THandle;
begin
  if Assigned(FEmptyEvent) and Assigned(FWaveOutThread) then begin
    handles[0] := FEmptyEvent.Handle;
    handles[1] := FWaveOutThread.Handle;

    WaitForMultipleObjects(2, @handles, False, INFINITE);
  end;
end;

procedure TSoundOut.WaveWrite;
begin
  FBufsCS.Lock;
  try
    InterlockedIncrement(FUsedBufCount);
    FEmptyEvent.ResetEvent;
    Assert(FUsedBufCount <= PCMOutBufCount);
    FWaveOutHeaders[FBufIndex].dwBufferLength := FBufAvailableLen;
    FBufAvailableLen := 0;
  finally
    FBufsCS.Unlock;
  end;

  if not Assigned(FWaveStream) then begin
    Assert(FWaveOutHandle <> 0);
    CheckWaveOut(MMSystem.WaveOutWrite(FWaveOutHandle, @(FWaveOutHeaders[FBufIndex]),
      SizeOf(FWaveOutHeaders[FBufIndex])),
      'TSoundOut.WaveWrite');
  end
  else begin
    FWaveOutThread.PostMessage(MPM_WAVEFILEWRITE, 0, FBufIndex );
  end;
  FBufIndex := (FBufIndex+1) mod PCMOutBufCount;
end;

function  TSoundOut.Write(const Buf; Count: Integer): Integer;
var
  bufRoomLen: Integer;
  curPos: Integer;
  writeLen: Integer;
begin
  curPos := 0;
  Result := 0;
  while 0 < Count do  begin
    if not HasRoom then begin
      Exit;
    end;

    bufRoomLen := FBufItemSize-FBufAvailableLen;
    if Count <= bufRoomLen then begin
      writeLen := Count;
    end
    else begin
      writeLen := bufRoomLen;
    end;

    FBufsCS.Lock;
    try
      Move(PChar(@Buf)[curPos], FBufs[FBufIndex][FBufAvailableLen], writeLen);
      Dec(Count, writeLen);
      Inc(Result, writeLen);
      Inc(FBufAvailableLen, writeLen);
      Inc(curPos, writeLen);

      if FBufItemSize <= FBufAvailableLen then begin
        WaveWrite;
      end;
    finally
      FBufsCS.Unlock;
    end;
  end;
end;



{ TMP3Info }

type
  TID3V1Tag = packed record
    Tag: array[0..2] of Char;
    Title: array[0..29] of Char;
    Artist: array[0..29] of Char;
    Album: array[0..29] of Char;
    Year: array[0..3] of Char;
    Comment: array[0..29] of Char;
    Genre: Byte;
  end;
  PID3V1Tag = ^TID3V1Tag;

  TID3V2TagHeader = packed record
    Tag: array[0..2] of Char;
    Version: Byte;
    Revision: Byte;
    Flags: Byte;
    Size: array[0..3] of Byte;
  end;
  PID3V2TagHeader = ^TID3V2TagHeader;
  TID3V2FrameHeader = packed record
    Tag: array[0..3] of Char;
    Size: LongInt;
    Flags: SmallInt;
  end;
  PID3V2FrameHeader = ^TID3V2FrameHeader;

  TRiffHeadChunk = packed record
    ID: array[0..3] of Char;
    Size: LongInt;
    FormType: array[0..3] of Char;
  end;
  PRiffHeadChunk = ^TRiffHeadChunk;
  TRiffListChunk = TRiffHeadChunk;
  PRIffListChunk = ^TRiffListChunk;
  TRiffCommonChunk = packed record
    ID: array[0..3] of Char;
    Size: LongInt;
  end;
  PRiffCommonChunk = ^TRiffCommonChunk;
  TRiffFmtChunk = packed record
    ID: array[0..3] of Char;
    Size: LongInt;
    Format: SmallInt;
    Modus: SmallInt;
    SampleRate: Integer;
    BitRate: Integer;
    BlockSize: SmallInt;
    SampleDepth: SmallInt;
  end;
  PRiffFmtChunk = ^TRiffFmtChunk;

  TMacBinHeader = packed record
    Null1: Byte;
    FileNameLength: Byte;
    FileName: array[0..62] of Char;
    FileType: array[0..3] of Byte;
    FileCreateer: array[0..3] of Byte;
    OriginalFinderFlags: Byte;
    Null2: Byte;
    WindowTop: array[0..1] of Byte;
    WindowLeft: array[0..1] of Byte;
    WindowFolderID: array[0..1] of Byte;
    ProtectedFlag: Byte;
    Null3: Byte;
    DataForkLength: array[0..3] of Byte;
    ResourceForkLength: array[0..3] of Byte;
    CreationDate: array[0..3] of Byte;
    ModifiedDate: array[0..3] of Byte;
    GetInfoCommentLength: array[0..1] of Byte;
    FinderFlags: Byte;
    Signature: array[0..3] of Byte;
    Script: Byte;
    ExtendedFinderFlags: Byte;
    Unused1: array[0..7] of Byte;
    TotalFileLength: array[0..3] of Byte;
    SecondaryHeaderLength: array[0..1] of Byte;
    VersionNumber: Byte;
    MinimumVersionNeeded: Byte;
    CRC: array[0..1] of Byte;
    Unused2: array[0..1] of Byte;
  end;
  PMacBinHeader = ^TMacBinHeader;

procedure TMP3Info.Clear;

  procedure ClearStrings(strs: TStrings);
  begin
    if Assigned(strs) then begin
      while 0 < strs.Count do begin
        strs.Objects[0].Free;
        strs.Delete(0);
      end;
    end;
  end;

begin
  FReader := nil;

  FInfoType := [];
  FFileName := '';

  FBodyPos := 0;
  FBodyLength := MaxInt;

  FRIFFDataPos := 0;
  FRIFFDataLength := MaxInt;

  ClearStrings(FRIFFInfos);
  ClearStrings(FID3V1Infos);
  ClearStrings(FID3V2Infos);
  ClearStrings(FLyricsInfos);
end;

constructor TMP3Info.Create;
begin
  inherited Create;

  FRIFFInfos    := TStringList.Create;
  FID3V1Infos   := TStringList.Create;
  FID3V2Infos   := TStringList.Create;
  FLyricsInfos  := TStringList.Create;

  FNeedInfoType := [mitID3V1, mitID3V2, mitRiff];
end;

destructor TMP3Info.Destroy;
begin
  Clear;

  FRIFFInfos.Free;
  FID3V1Infos.Free;
  FID3V2Infos.Free;
  FLyricsInfos.Free;

  inherited Destroy;
end;


function TMP3Info.GetAlbum: String;
begin
  Result := MaxLenString([
    IIFStringOrNull(mitID3V1 in FNeedInfoType, FID3V1Infos.Values['ALBUM']),
    IIFStringOrNull(mitID3V2 in FNeedInfoType, FID3V2Infos.Values['TALB']),
    IIFStringOrNull(mitRiff  in FNeedInfoType, FRIFFInfos.Values['IPRD'])]);
end;

function TMP3Info.GetArtist: String;
begin
  Result := MaxLenString([
    IIFStringOrNull(mitID3V1 in FNeedInfoType, FID3V1Infos.Values['ARTIST']),
    IIFStringOrNull(mitID3V2 in FNeedInfoType, FID3V2Infos.Values['TPE1']),
    IIFStringOrNull(mitRiff  in FNeedInfoType, FRIFFInfos.Values['IART'])]);
end;

function TMP3Info.GetComment: String;
begin
  Result := MaxLenString([
    IIFStringOrNull(mitID3V1 in FNeedInfoType, FID3V1Infos.Values['COMMENT']),
    IIFStringOrNull(mitID3V2 in FNeedInfoType, FID3V2Infos.Values[' ']),
    IIFStringOrNull(mitRiff  in FNeedInfoType, FRIFFInfos.Values['ICMT'])]);
end;

function TMP3Info.GetGenre: String;
begin
  Result := MaxLenString([
    IIFStringOrNull(mitID3V1 in FNeedInfoType, FID3V1Infos.Values['GENRE']),
    IIFStringOrNull(mitID3V2 in FNeedInfoType, FID3V2Infos.Values['TIT1']),
    IIFStringOrNull(mitRiff  in FNeedInfoType, FRIFFInfos.Values['IGNR'])]);
end;

function TMP3Info.GetGenreIndex: Integer;
begin
  Result := StrToIntDef(IIFStringOrNull(mitID3V1 in FNeedInfoType, FID3V1Infos.Values['GENREIDX']),-1);
end;

function TMP3Info.GetLyrics: String;
begin
  Result := IIFStringOrNull(mitLyrics in FNeedInfoType, FLyricsInfos.Values['LYR']);

  if Result = '' then begin
    Result := MaxLenString([
      IIFStringOrNull(mitRiff  in FNeedInfoType, FRIFFInfos.Values['ILYC'])]);
  end;
end;

function TMP3Info.GetTitle: String;
begin
  Result := MaxLenString([
    IIFStringOrNull(mitID3V1 in FNeedInfoType, FID3V1Infos.Values['TITLE']),
    IIFStringOrNull(mitID3V2 in FNeedInfoType, FID3V2Infos.Values['TIT2']),
    IIFStringOrNull(mitRiff  in FNeedInfoType, FRIFFInfos.Values['INAM'])]);
  if Result = '' then begin
    Result := ExtractFileName(FFileName);
  end;
end;

function TMP3Info.GetTrack: String;
begin
  Result := MaxLenString([
    IIFStringOrNull(mitID3V1 in FNeedInfoType, FID3V1Infos.Values['TRACK'])]);
end;

function TMP3Info.GetYear: String;
begin
  Result := MaxLenString([
    IIFStringOrNull(mitID3V1 in FNeedInfoType, FID3V1Infos.Values['YEAR']),
    IIFStringOrNull(mitID3V2 in FNeedInfoType, FID3V2Infos.Values['TYER']),
    IIFStringOrNull(mitRiff  in FNeedInfoType, FRIFFInfos.Values['ICRD'])]);
end;

class function TMP3Info.IIFStringOrNull(Cond: Boolean;
  Str: String): String;
begin
  if Cond then begin
    Result := Str;
  end
  else begin
    Result := '';
  end;
end;

class function TMP3Info.MaxLenString(Strs: array of String): String;
var
  idx: Integer;
begin
  Result := '';
  for idx := 0 to High(Strs) do begin
    if System.Length(Result) < System.Length(Strs[idx]) then begin
      Result := Strs[idx];
    end;
  end;
end;

function TMP3Info.QueryBody;
var
  h: TMpegHead;
  frameLength: Integer;
  retryBytes: Integer;

  procedure Retry;
  begin
    FReader.Skip(1);
    Inc(retryBytes);
  end;

begin
  Assert(FReader <> nil);

  Result := False;

  retryBytes := 0;
  while retryBytes < MaxRetryBytes do begin
    if not FReader.Fill(SizeOf(TMpegRawHead)) then begin
      Exit;
    end;

    frameLength := _head_info(FReader.Buffer[0], 0, h);
    if frameLength < 0 then begin
      Retry;
      Continue;
    end;

    if not(H.Option in [1, 2, 3]) then begin
      Retry;
      Continue;
    end;

    if H.Option = 3 then begin
      Inc(frameLength, H.Pad*4);
    end
    else begin
      Inc(frameLength, H.Pad);
    end;

    if not FReader.Fill(frameLength) then begin
      Exit;
    end;

    Result := True;
    FBodypos := FReader.Position;
    Exit;
  end;
end;

procedure TMP3Info.ReadFromFile(FileName: TFileName);
var
  reader: TMPStreamReader;
  fileStream: TFileStream;
begin
  try
    reader := nil;
    fileStream := nil;
    try
      reader := TMPStreamReader.Create(InBufSize);
      fileStream := TFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
      reader.Open(fileStream, True);
      SetReader(reader);
      FFileName := FileName;
      if not(ReadHead and QueryBody and ReadTail) then begin
        raise EMP3Error.Create(SInvalidMP3Format);
      end;
    finally
      SetReader(nil);
      reader.Free;
      fileStream.Free;
    end;
  except
    Clear;
    raise;
  end;
end;

function TMP3Info.ReadHead;
begin
  Result := False;

  if ReadMacBinHeader then begin
    Include(FInfoType, mitMacBin);
  end;

  if ReadRIFFHeader and
     SkipRIFFChunksTo('data') and
     ReadRIFFDataChunkHeader then begin
    Include(FInfoType, mitRiff);
  end;

  if ReadID3V2Tag then begin
    Include(FInfoType, mitID3V2);
  end;

  if not FReader.Fill(1) then begin
    Exit;
  end;

  Result := True;
end;

function TMP3Info.ReadID3V1Tag;
var
  tagPos: Integer;
  pTag: PID3V1Tag;
begin
  Assert(FReader <> nil);
  Assert(FReader.Seekable);

  Result := False;

  if mitMacBin in FInfoType then begin
    tagPos := FMacBinResourcePos-SizeOf(TID3V1Tag);
  end
  else begin
    tagPos := FReader.Size-SizeOf(TID3V1Tag);
  end;
  if (tagPos < 0) or (FReader.Size < tagPos) then begin
    Exit;
  end;

  FReader.Seek(tagPos, soFromBeginning);
  if not FReader.Fill(SizeOf(TID3V1Tag)) then begin
    Exit;
  end;
  pTag := PID3V1Tag(FReader.Buffer);
  if StrLComp(pTag^.Tag, 'TAG', 3) <> 0 then begin
    Exit;
  end;

  FID3V1Infos.Add('TITLE='+CharArrayToString(pTag^.Title, SizeOf(pTag^.Title)));
  FID3V1Infos.Add('ARTIST='+CharArrayToString(pTag^.Artist, SizeOf(pTag^.Artist)));
  FID3V1Infos.Add('ALBUM='+CharArrayToString(pTag^.Album, SizeOf(pTag^.Album)));
  FID3V1Infos.Add('YEAR='+CharArrayToString(pTag^.Year, SizeOf(pTag^.Year)));
  FID3V1Infos.Add('COMMENT='+CharArrayToString(pTag^.Comment, SizeOf(pTag^.Comment)));
  FID3V1Infos.Add('GENRE='+GenreTbl[Ord(pTag^.Genre)]);
  FID3V1Infos.Add('GENREIDX='+IntToStr(Ord(pTag^.Genre)));
  if pTag^.Comment[28] = #0 then begin
    FID3V1Infos.Add('TRACK='+IntToStr(Ord(pTag^.Comment[29])));
  end;

  FID3V1Pos := FReader.Position;
  if not FReader.Skip(SizeOf(TID3V1Tag)) then begin
    Exit;
  end;

  Result := True;
end;

function TMP3Info.ReadID3V2Tag;
var
  pTag: PID3V2TagHeader;
  tagHeaderSize: Integer;
  pFrame: PID3V2FrameHeader;
  extHeaderSize: LongInt;
  tagStartPos: Integer;
  tagEndPos: Integer;
  frameSize: LongInt;
  frameName: String;
  frameContents: String;
begin
  Assert(FReader <> nil);

  Result := False;

  tagStartPos := FReader.Position;
  if not FReader.Fill(SizeOf(TID3V2TagHeader)) then begin
    Exit;
  end;
  pTag := PID3V2TagHeader(FReader.Buffer);
  if StrLComp(pTag^.Tag, 'ID3', 3) <> 0 then begin
    Exit;
  end;

  with pTag^ do begin
    tagHeaderSize := Integer(Size[0]) shl 21+
               Integer(Size[1]) shl 14+
               Integer(Size[2]) shl 7+
               Integer(Size[3]);
  end;
  if tagHeaderSize <= 0 then begin
    Exit;
  end;

  if (pTag^.Version = 3) and ((pTag^.Flags and (1 shl 7)) = 0) then begin
    if (pTag^.Flags and (1 shl 6)) <> 0 then begin
      if not FReader.Fill(SizeOf(TID3V2TagHeader)+SizeOf(extHeaderSize)) then begin
        Exit;
      end;

      extHeaderSize := ReadBigEndianInt(FReader.Buffer[SizeOf(TID3V2TagHeader)]);
      if (extHeaderSize < 0) or (tagHeaderSize < extHeaderSize) then begin
        Exit;
      end;
    end
    else begin
      extHeaderSize := 0;
    end;
    tagEndPos := tagStartPos+SizeOf(TID3V2TagHeader)+extHeaderSize+tagHeaderSize;

    if not FReader.Skip(SizeOf(TID3V2TagHeader)+extHeaderSize) then begin
      Exit;
    end;

    while FReader.Position+SizeOf(TID3V2FrameHeader) <= tagEndPos do begin
      if not FReader.Fill(SizeOf(TID3V2FrameHeader)) then begin
        Exit;
      end;
      pFrame := PID3V2FrameHeader(FReader.Buffer);
      frameSize := ReadBigEndianInt(pFrame^.Size);
      if frameSize <= 0 then begin
        if not FReader.Skip(tagEndPos-FReader.Position) then begin
          Exit;
        end
        else begin
          Break;
        end;
      end;

      if SizeOf(TID3V2FrameHeader)+frameSize <= FReader.BufSize then begin
        if not FReader.Fill(SizeOf(TID3V2FrameHeader)+frameSize) then begin
          Exit;
        end;

        frameName := CharArrayToString(pFrame^.Tag, SizeOf(pFrame^.Tag));
        if (Ord(FReader.Buffer[SizeOf(TID3V2FrameHeader)]) = 1) and
           (frameName[1] = 'T') then begin
          frameContents := WideCharLenToString(@(FReader.Buffer[SizeOf(TID3V2FrameHeader)+1]), (frameSize-1) div 2);
        end
        else if (frameName = 'COMM') or (frameName = 'WXXX') then begin
          frameContents := CharArrayToStringFromRight(@(FReader.Buffer[SizeOf(TID3V2FrameHeader)+1]), frameSize-1);
        end
        else begin
          frameContents := CharArrayToString(@(FReader.Buffer[SizeOf(TID3V2FrameHeader)+1]), frameSize-1);
        end;
        FID3V2Infos.Add(frameName+'='+frameContents);
      end;
      if (tagEndPos < FReader.Position+SizeOf(TID3V2FrameHeader)+frameSize) or
         not FReader.Skip(SizeOf(TID3V2FrameHeader)+frameSize) then begin
        Exit;
      end;
    end;

    if FReader.Position <> tagEndPos then begin
      Exit;
    end;
  end
  else begin
    if not FReader.Skip(SizeOf(TID3V2TagHeader)+tagHeaderSize) then begin
      Exit;
    end;
  end;

  FBodyPos := FReader.Position;
  if FBodyLength < MaxInt then begin
    Dec(FBodyLength, tagHeaderSize+SizeOf(TID3V2TagHeader));
  end;

  Result := True;
end;

function TMP3Info.ReadLyrics;
var
  startIDPos: Integer;        //  searchStartIDPos  'LYRICSBEGIN' ւ
                              //  ItZbg
  endIDPos: Integer;          //  'LYRICSEND' ܂ 'LYRICS200' ւ̃ItZbg
  searchStartIDPos: Integer;  //  'LYRICSBEGIN' ̒TJnʒuItZbg
  v2WidthStr: String;
  v2Width: Integer;
  lyrics: String;
const
  startID = 'LYRICSBEGIN';
  startIDLen = 11;
  v1EndID = 'LYRICSEND';
  v2EndID = 'LYRICS200';
  endIDLen = 9;
  v2WidthLen = 6;
  v1MaxLen = 5100;
  fieldIDLen = 3;
  fieldWidthLen = 5;

  function ReadFromReader(var Buf: String; Count: Integer): Boolean;
  var
    doneLen: Integer;
    readLen: Integer;
  begin
    Assert(0 <= Count);

    Result := False;

    SetLength(Buf, Count);
    doneLen := 0;

    while 0 < Count do begin
      if FReader.BufSize < Count then begin
        readLen := FReader.BufSize;
      end
      else begin
        readLen := Count;
      end;
      if not FReader.Fill(readLen) then begin
        Exit;
      end;
      Move(FReader.Buffer[0], Buf[doneLen+1], readLen);
      if not FReader.Skip(readLen) then begin
        Exit;
      end;
      Inc(doneLen, readLen);
      Dec(Count, readLen);
    end;

    Result := True;
  end;

  function ReadField: Boolean;
  var
    fieldID: String;
    fieldWidthStr: String;
    fieldWidth: Integer;
    field: String;
  begin
    Result := False;

    if not FReader.Fill(fieldIDLen+fieldWidthLen) then begin
      Exit;
    end;
    fieldID := CharArrayToString(FReader.Buffer, fieldIDLen);
    fieldWidthStr := CharArrayToString(@(FReader.Buffer[fieldIDLen]), fieldWidthLen);
    fieldWidth := StrToIntDef(fieldWidthStr, 0);
    if fieldWidth <= 0 then begin
      Exit;
    end;
    if not FReader.Skip(fieldIDLen+fieldWidthLen) then begin
      Exit;
    end;
    if endIDPos-v2WidthLen < FReader.Position+fieldWidth then begin
      Exit;
    end;
    if not ReadFromReader(field, fieldWidth) then begin
      Exit;
    end;
    FLyricsInfos.Add(fieldID+'='+field);

    Result := True;
  end;

begin
  Assert(FReader <> nil);
  Assert(FReader.Seekable);

  Result := False;

  if mitID3V1 in FInfoType then begin
    endIDPos := FID3V1Pos-endIDLen;
  end
  else if mitMacBin in FInfoType then begin
    endIDPos := FMacBinResourcePos-endIDLen;
  end
  else begin
    endIDPos := FReader.Size-endIDLen;
  end;

  if (endIDPos < 0) or (FReader.Size < endIDPos) then begin
    Exit;
  end;

  FReader.Seek(endIDPos, soFromBeginning);
  if not FReader.Fill(endIDLen) then begin
    Exit;
  end;

  if StrLComp(PChar(FReader.Buffer), v1EndID, endIDLen) = 0 then begin
    searchStartIDPos := endIDPos-v1MaxLen;
    if searchStartIDPos < 0 then begin
      searchStartIDPos := 0;
    end;
    FReader.Seek(searchStartIDPos, soFromBeginning);
    if not ReadFromReader(lyrics, endIDPos-FReader.Position) then begin
      Exit;
    end;
    startIDPos := Pos(startID, lyrics);
    if startIDPos <= 0 then begin
      Exit;
    end;
    FLyricsInfos.Add('LYRICS='+Copy(lyrics, startIDPos+startIDLen, MaxInt));
    FLyricsPos := searchStartIDPos+startIDPos-1;
    Result := True;
  end
  else if StrLComp(PChar(FReader.Buffer), v2EndID, endIDLen) = 0 then begin
    FReader.Seek(endIDPos-v2WidthLen, soFromBeginning);
    if not FReader.Fill(v2WidthLen) then begin
      Exit;
    end;
    v2WidthStr := CharArrayToString(FReader.Buffer, v2WidthLen);
    v2Width := StrToIntDef(v2WidthStr, 0);
    if v2Width <= 0 then begin
      Exit;
    end;
    FLyricsPos := endIDPos-v2Width-v2WidthLen;
    if FLyricsPos < 0 then begin
      Exit;
    end;
    FReader.Seek(FLyricsPos, soFromBeginning);
    if not FReader.Fill(startIDLen) then begin
      Exit;
    end;
    if StrLComp(FReader.Buffer, startID, startIDLen) <> 0 then begin
      Exit;
    end;
    if not FReader.Skip(startIDLen) then begin
      Exit;
    end;
    while FReader.Position < endIDPos-v2WidthLen do begin
      if not ReadField then begin
        Exit;
      end;
    end;
    Result := True;
  end;
end;

function TMP3Info.ReadMacBinHeader;
var
  pHeader: PMacBinHeader;
  dataLength: LongInt;
  resourceLength: LongInt;
begin
  Assert(FReader <> nil);

  Result := False;

  if not FReader.Fill(SizeOf(TMacBinHeader)) then begin
    Exit;
  end;
  pHeader := PMacBinHeader(FReader.Buffer);
  with pHeader^ do begin
    if (Null1 = 0) and
       (Null2 = 0) and
       (Null3 = 0) and
       (1 <= FileNameLength) and (FileNameLength <= 31) then begin
      dataLength := ReadBigEndianInt(DataForkLength[0]);
      resourceLength := ReadBigEndianInt(ResourceForkLength[0]);
      if (dataLength < 0) or (resourceLength < 0) then begin
        Exit;
      end;

      if not FReader.Skip(SizeOf(TMacBinHeader)) then begin
        Exit;
      end;
      FMacBinDataPos := FReader.Position;
      FMacBinDataLength := dataLength;
      FMacBinResourcePos := FMacBinDataPos+FMacBinDataLength;
      FMacBinResourceLength:= resourceLength;

      FBodyPos := FMacBinDataPos;
      FBodyLength := dataLength;

      Result := True;
    end;
  end;
end;

function TMP3Info.ReadMacBinResource;
begin
  Assert(FReader <> nil);

  Result := False;

  FReader.Seek(FMacBinResourceLength, soFromBeginning);
  if not FReader.Skip(FMacBinResourceLength) then begin
    Exit;
  end;

  Result := True;
end;

function TMP3Info.ReadRIFFDataChunkHeader;
var
  pCommonChunk: PRiffCommonChunk;
begin
  Assert(FReader <> nil);

  Result := False;

  if not FReader.Fill(SizeOf(TRiffCommonChunk)) then begin
    Exit;
  end;
  pCommonChunk := PRiFFCommonChunk(FReader.Buffer);
  if pCommonChunk^.Size <= 0 then begin
    Exit;
  end;

  if StrLComp(pCommonChunk^.ID, 'data', 4) = 0 then begin
    FRIFFDataLength := pCommonChunk^.Size;
    if not FReader.Skip(SizeOf(TRiffCommonChunk)) then begin
      Exit;
    end;
    FRIFFDataPos := FReader.Position;

    FBodyPos := FRIFFDataPos;
    FBodyLength := FRIFFDataLength;

    Result := True;
  end;
end;

function TMP3Info.ReadRIFFHeader;
var
  pHeadChunk: PRiffHeadChunk;
begin
  Assert(FReader <> nil);

  Result := False;

  if not FReader.Fill(SizeOf(TRiffHeadChunk)) then begin
    Exit;
  end;

  pHeadChunk := PRiFFHeadChunk(FReader.Buffer);
  if StrLComp(pHeadChunk^.ID, 'RIFF', 4) <> 0 then begin
    Exit;
  end;

  if not FReader.Skip(SizeOf(TRiffHeadChunk)) then begin
    Exit;
  end;

  Result := True;
end;

function TMP3Info.ReadRIFFListInfo;
var
  pListChunk: PRiffListChunk;
  pCommonChunk: PRiffCommonChunk;
  infoName: String;
  info: String;
  infoSize: Integer;
  listEndPos: Integer;
begin
  Assert(FReader <> nil);

  Result := False;

  if not FReader.Fill(SizeOf(TRiffCommonChunk)) then begin
    Exit;
  end;
  pCommonChunk := PRiFFCommonChunk(FReader.Buffer);
  if pCommonChunk^.Size < 0 then begin
    Exit;
  end;

  if StrLComp(pCommonChunk^.ID, 'LIST', 4) = 0 then begin

    if not FReader.Fill(SizeOf(TRiffListChunk)) then begin
      Exit;
    end;
    pListChunk := PRiFFListChunk(FReader.Buffer);

    if StrLComp(pListChunk^.FormType, 'INFO', 4) = 0 then begin
      listEndPos := Int64(FReader.Position)+pListChunk^.Size+
        SizeOf(TRiffCommonChunk);

      if not FReader.Skip(SizeOf(TRiffListChunk)) then begin
        Exit;
      end;

      while FReader.Position < listEndPos do begin
        if not FReader.Fill(SizeOf(TRiffCommonChunk)) then begin
          Exit;
        end;
        pCommonChunk := PRiFFCommonChunk(FReader.Buffer);

        infoName := CharArrayToString(pCommonChunk^.ID, SizeOf(pCommonChunk^.ID));
        infoSize := pCommonChunk^.Size;
        if not FReader.Skip(SizeOf(TRiffCommonChunk)) then begin
          Exit;
        end;

        if infoSize < 0 then begin
          Exit;
        end;

        if infoName = 'IID3' then begin
          Result := True;
          Exit;
        end;

        if not FReader.Fill(infoSize) then begin
          Exit;
        end;
        info := CharArrayToString(FReader.Buffer, infoSize);
        if (infoName <> '') and (info <> '') then begin
          FRiffInfos.Add(infoName+'='+info);
        end;

        if not FReader.Skip(RoundUpToEven(infoSize)) then begin
          Exit;
        end;
      end;
      Result := True;
    end;
  end;
end;

function TMP3Info.ReadTail;
begin
  Assert(FReader <> nil);

  Result := False;

  if not FReader.Seekable then begin
    Exit;
  end;

  if FBodyLength = MaxInt then begin
    FBodyLength := FReader.Size-FBodyPos;
  end;

  if mitRIFF in FInfoType then begin
    try
      FReader.Seek(RoundUpToEven(FRIFFDataPos+FRIFFDataLength), soFromBeginning);
      SkipRIFFChunksTo('LIST', 'INFO');
      ReadRIFFListInfo;
    except
      //
    end;
  end;

  if ReadID3V1Tag then begin
    Include(FInfoType, mitID3V1);
  end;

  if ReadLyrics then begin
    Include(FInfoType, mitLyrics);
  end;

  if mitMacBin in FInfoType then begin
    ReadMacBinResource;
  end;

  Result := True;
end;

procedure TMP3Info.SetReader(Reader: TMPStreamReader);
begin
  if Reader <> nil then begin
    Clear;
  end;

  FReader := Reader;
end;

function TMP3Info.SkipRIFFChunksTo(const ChunkID, FormType: String): Boolean;
var
  pCommonChunk: PRiffCommonChunk;
  pListChunk: PRIFFListChunk;
begin
  Assert(FReader <> nil);

  Result := False;

  while True do begin
    if not FReader.Fill(SizeOf(TRiffCommonChunk)) then begin
      Exit;
    end;
    pCommonChunk := PRiFFCommonChunk(FReader.Buffer);
    if pCommonChunk^.Size <= 0 then begin
      Exit;
    end;

    if StrLComp(pCommonChunk^.ID, PChar(ChunkID), 4) = 0 then begin
      if FormType <> '' then begin
        if not FReader.Fill(SizeOf(TRiffListChunk)) then begin
          Exit;
        end;
        pListChunk := PRiFFListChunk(FReader.Buffer);
        if StrLComp(pListChunk^.FormType, PChar(FormType), 4) = 0 then begin
          Result := True;
          Exit;
        end;
      end
      else begin
        Result := True;
        Exit;
      end;
    end;

    if not FReader.Skip(RoundUpToEven(pCommonChunk^.Size+SizeOf(TRiffCommonChunk))) then begin
      Exit;
    end;
  end;
end;

{ TMP3Player }

function CpuCapsToCpuCapabilities(Specs: LongInt): TMP3CpuCapabilities;
begin
  Result := [];

  if Specs and tMMX <> 0 then begin
    Include(Result, mccMMX);
  end;
  if Specs and t3DN <> 0 then begin
    Include(Result, mcc3DNow);
  end;
  if Specs and tSSE <> 0 then begin
    Include(Result, mccKNI);
  end;
  if Specs and tE3DN <> 0 then begin
    Include(Result, mccE3DNow);
  end;
  if Specs and tCMOV <> 0 then begin
    Include(Result, mccCMOV);
  end;
  if Specs and tEMMX <> 0 then begin
    Include(Result, mccEMMX);
  end;
end;

function CpuCapabilitiesToCpuCaps(Capabilities: TMP3CpuCapabilities): LongInt;
begin
  Result := 0;
  if mccMMX in Capabilities then begin
    Inc(Result, tMMX);
  end;
  if mcc3DNow in Capabilities then begin
    Inc(Result, t3DN);
  end;
  if mccKNI in Capabilities then begin
    Inc(Result, tSSE);
  end;
  if mccE3DNow in Capabilities then begin
    Inc(Result, tE3DN);
  end;
  if mccCMOV in Capabilities then begin
    Inc(Result, tCMOV);
  end;
  if mccEMMX in Capabilities then begin
    Inc(Result, tEMMX);
  end;
end;


procedure TMP3Player.ChangePosition(Sender: TObject);
begin
  if not(csDestroying in ComponentState) and
    Assigned(FOnChangePosition) then begin
    FOnChangePosition(Self);
  end;
end;

procedure TMP3Player.ChangeStatus(Sender: TObject);
begin
  if not(csDestroying in ComponentState) and
    Assigned(FOnChangeStatus) then begin
    FOnChangeStatus(Self);
  end;
end;

procedure TMP3Player.Close;
begin
  if not IsOpen then begin
    Exit;
  end;

  if FStatus <> mstStop then begin
    Stop;
  end;

  if Assigned(FReader) then begin
    FReader.Close;
  end;

{$ifdef UseReadAhead}
  if Assigned(FReadAheadStream) then begin
    FReadAheadStream.Close;
  end;
{$endif}

  if Assigned(FOutBuf) then begin
    FreeMemAlign(FOutBuf);
    FOutBuf := nil;
  end;

  FFileName := '';

  if Assigned(FStream) and (mstOwn in FStreamType) then begin
    FStream.Free;
  end;
  FStream := nil;

  FInfo.Clear;
  FillChar(FFirstHeader, SizeOf(FFirstHeader), 0);
  FFirstRawHead := 0;
  FBitRate := 0;
  FChannels := 0;
  FLayer := 0;
  FVersion := 0;
  FSamplingRate := 0;
  FPCMDoneOutBytes := 0;
  FPosition := 0;
  FOutFrameBytes := 0;
  FOutputBytes := 0;

  SetStatus(mstStop);
end;

constructor TMP3Player.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FAutoPlay := True;
  FAutoOpen := True;
  FVolume := 100;
  FStatus := mstStop;
  FChangePosStep := 400;
  FNoisySeek := True;
  FDecodePriority := tpNormal;
  FInfo := TMP3Info.Create;

  FUsingCpuCapabilities := MccAll;

  FWindowHandle := AllocateHWnd(WndProc);

  FFramePosList := TThreadList.Create;

  FReader := TMPStreamReader.Create(InBufSize);

  FDeviceID := WAVE_MAPPER;

  FSoundOut := TSoundOut.Create;
  with FSoundOut do begin
    DoneOutputStep := FChangePosStep;
    OnThreadError := Self.ThreadError;
    OnDoneOutput := PCMDoneOutput;
  end;
  FSoundOutMutex := TMPSimpleMutex.Create;

  FEqualizerCount := 6;

  FDecodeCS := TMPSimpleMutex.Create;

  FDecodeThread := TMPLoopThread.Create(Self);
  with FDecodeThread do begin
    OnThreadError := ThreadError;
    Resume;
  end;

{$ifdef UseReadAhead}
  FReadAheadStream := TMPReadAheadStream.Create(ReadAheadBufSize);
{$endif}
end;

destructor TMP3Player.Destroy;
begin
  Stop;
  Close;

  DeallocateHWnd(FWindowHandle);
  FWindowHandle := 0;

  FSoundOut.Free;

  FDecodeThread.Free;

  FSoundOutMutex.Free;

  FDecodeCS.Free;

  FReader.Free;

{$ifdef UseReadAhead}
  FReadAheadStream.Free;
{$endif}

  FFramePosList.Free;

  FInfo.Free;

  inherited Destroy;
end;

procedure TMP3Player.EndPlay(Sender: TObject);
begin
  if Assigned(FOnEndPlay) then begin
    FOnEndPlay(Sender, FEndPlayReason);
  end;
  FEndPlayReason := merStoped;
end;

function TMP3Player.GetAlbum: String;
begin
  Result := FInfo.Album;
end;

function TMP3Player.GetArtist: String;
begin
  Result := FInfo.Artist;
end;

function TMP3Player.GetCapabilities: TMP3Capabilities;
begin
  Result := [mcbCanOpen];

  if IsOpen then begin
    Include(Result, mcbCanClose);

    if FStatus in [mstStop] then begin
      Include(Result, mcbCanPlay);
    end;

    if FStatus in [mstPlay, mstPause] then begin
      Include(Result, mcbCanStop);
    end;

    if (FStatus in [mstPlay]) and (FOutputFileName = '') then begin
      Include(Result, mcbCanPause);
    end;

    if (FStatus in [mstPause])  and (FOutputFileName = '') then begin
      Include(Result, mcbCanUnpause);
    end;

    if FReader.Seekable and (FStatus in [mstPlay, mstPause]) and
      (FOutputFileName = '') then begin
      Include(Result, mcbCanSeek);
    end;

    if FStatus in [mstStop] then begin
      Include(Result, mcbCanPlayToFile);
    end;
  end;
end;

function TMP3Player.GetComment: String;
begin
  Result := FInfo.Comment;
end;

function TMP3Player.GetDeviceCount: Integer;
begin
  Result := FSoundOut.GetDeviceCount;
end;

function TMP3Player.GetDeviceNames(Idx: Integer): String;
begin
  Result := FSoundOut.GetDeviceName(Idx);
end;

function TMP3Player.GetEqualizer(Index: Integer): Integer;
begin
  if (Index < 0) or (32 <= Index) then begin
    raise EListError.CreateFmt(SListIndexError, [Index]);
  end;

  Result := FEqualizer[Index];
end;

function TMP3Player.GetEqualizerFreq(Index: Integer): Integer;
begin
  if (Index < 0) or (32 <= Index) then begin
    raise EListError.CreateFmt(SListIndexError, [Index]);
  end;

  if (FEqualizerMode = memSubBand) and (FSamplingRate = 0) then begin
    Result := 0;
  end
  else begin
    Result := FEqualizerFreq[Index];
  end;
end;

function TMP3Player.GetFrameBytes(var Buf; var H: TMpegHead): Integer;
var
  rawHead: TMpegRawHead;
begin
  Result := _head_info(Buf, 0, H);

  if 0 < Result then begin

    if not(H.Option in [1, 2, 3]) then begin
      Result := 0;
      Exit;
    end;

    Move(Buf, rawHead, SizeOf(rawHead));
    if not IsValidRawHeader(rawHead) then begin
      Result := 0;
      Exit;
    end;

    if FLayer = 1 then begin
      Inc(Result, H.Pad*4);
    end
    else begin
      Inc(Result, H.Pad);
    end;
  end;
end;

function TMP3Player.GetGenre: String;
begin
  Result := FInfo.Genre;
end;

function TMP3Player.GetGenreIndex: Integer;
begin
  Result := FInfo.GenreIndex;
end;

function TMP3Player.GetHasCpuCapabilities: TMP3CpuCapabilities;
begin
{$ifdef ASM_X86}
  Result := CpuCapsToCpuCapabilities(CPUSpecs);
{$else}
  Result := MccAll;
{$endif}
end;

class function TMP3Player.GetID3Genre(Idx: Byte): String;
begin
  Result := GenreTbl[Idx];
end;

function TMP3Player.GetID3V1Infos: TStrings;
begin
  Result := FInfo.ID3V1Infos;
end;

function TMP3Player.GetID3V2Infos: TStrings;
begin
  Result := FInfo.ID3V2Infos;
end;

function TMP3Player.GetInfoType: TMP3InfoType;
begin
  Result := FInfo.InfoType;
end;

function TMP3Player.GetInvertPolarity: Boolean;
begin
  FDecodeCS.Lock;
  try
    Result := _get_invert_polarity <> 0;
  finally
    FDecodeCS.Unlock;
  end;
end;

function TMP3Player.GetIsOpen: Boolean;
begin
  Result := FStream <> nil;
end;

function TMP3Player.GetLength: integer;
begin
  Result := 0;
  if (0 < FSamplingRate) and (0 < FOutputBytes) then begin
    Result := Int64(FOutputBytes)*1000 div (FSamplingRate*FChannels*2);
  end
  else if (0 < FBitRate) and (FBodyLength < MaxInt) then begin
    Result := Int64(FBodyLength)*8*1000 div FBitRate;
  end;
end;

function TMP3Player.GetNeedInfoType: TMP3InfoType;
begin
  Result := FInfo.NeedInfoType;
end;

function TMP3Player.GetPosition: Integer;
begin
  UpdatePosition;
  Result := FPosition;
end;

function TMP3Player.GetRIFFInfos: TStrings;
begin
  Result := FInfo.RIFFInfos;
end;

function TMP3Player.GetTitle: String;
begin
  Result := FInfo.Title;
  if (Result = '') and (FFileName <> '') then begin
    Result := ExtractFileName(FFileName);
  end;
end;

function TMP3Player.GetTrack: String;
begin
  Result := FInfo.Track;
end;

function TMP3Player.GetYear: String;
begin
  Result := FInfo.Year;
end;

function TMP3Player.InitLMC(var h: TMpegHead; framebytes_arg,
  reduction_code, transform_code, convert_code,
  freq_limit: Integer): Integer;
begin
  if FLayer = 1 then begin
    Dec(framebytes_arg, h.Pad*4);
  end
  else begin
    Dec(framebytes_arg, h.Pad);
  end;

  Result := _audio_decode_init(h, framebytes_arg, reduction_code,
    transform_code, convert_code, freq_limit);

  if Result <> 0 then begin
    FNeedInitDecode := False;
    FRetryBytes := 0;
  end;
end;

function TMP3Player.IsValidRawHeader(RawH: TMpegRawHead): Boolean;
const
  mask = $000CFEFF;
begin
  Result := (FFirstRawHead and mask) = (RawH and mask);
end;

procedure TMP3Player.Loaded;
begin
  inherited Loaded;

  if (FEqualizerMode = memFreq) and
    not(csDesigning in ComponentState) then begin
    SetEqualizerFreqs(60, 16000);
  end;

  if FAutoOpen and (FFileName <> '') and
    not(csDesigning in ComponentState) then begin
    Open;
  end;
end;

procedure TMP3Player.MPMChangeEqualizer(var Msg: TMessage);

  function SubBandFreq(N: Integer): Integer;
  begin
    Assert(0 < FSamplingRate);
    Assert(0 <= N);
    Assert(N < 32);

    Result := Round(FSamplingRate/64.0*(N+0.5));
  end;

  function NSubBandFreq(N: Integer): Integer;
  begin
    Assert(0 < FSamplingRate);
    Assert(0 <= N);
    Assert(N < 576);

    Result := Round(FSamplingRate/1152.0*(N+0.5));
  end;

  procedure FreqMode;
  var
    bandIdx: Integer;
    freqIdx: Integer;
    nearestFreqIdx: Integer;
    minDistFreq: Single;
    distFreq: Single;
    freq: Integer;
  begin
    if FLayer = 3 then begin
      _enableEQ_addr^ := 0;
      _n_enableEQ_addr^ := Ord(FEqualizerEnabled);
      if FEqualizerEnabled then begin
        for bandIdx := 0 to 575 do begin
          minDistFreq := MaxInt;
          nearestFreqIdx := 0;
          for freqIdx := 0 to FEqualizerCount-1 do begin
            freq := FEqualizerFreq[freqIdx];
            if freq < 1 then begin
              freq := 1;
            end;
            distFreq := 1.0*freq/NSubBandFreq(bandIdx);
            if distFreq < 1.0 then begin
              distFreq := 1.0/distFreq;
            end;
            if distFreq < minDistFreq then begin
              minDistFreq := distFreq;
              nearestFreqIdx := freqIdx;
            end;
          end;
          _n_equalizer_addr(bandIdx)^ :=
            Power(10, FEqualizer[nearestFreqIdx]/100.0);
        end;
      end;
    end
    else begin
      _enableEQ_addr^ := Ord(FEqualizerEnabled);
      _n_enableEQ_addr^ := 0;
      if FEqualizerEnabled then begin
        for bandIdx := 0 to 31 do begin
          minDistFreq := MaxInt;
          nearestFreqIdx := 0;
          for freqIdx := 0 to FEqualizerCount-1 do begin
            freq := FEqualizerFreq[freqIdx];
            if freq < 1 then begin
              freq := 1;
            end;
            distFreq := 1.0*freq/SubBandFreq(bandIdx);
            if distFreq < 1.0 then begin
              distFreq := 1.0/distFreq;
            end;
            if distFreq < minDistFreq then begin
              minDistFreq := distFreq;
              nearestFreqIdx := freqIdx;
            end;
          end;
          _equalizer_addr(bandIdx)^ :=
            Power(10, FEqualizer[nearestFreqIdx]/100.0);
        end;
      end;
    end;
  end;

  procedure SubBandMode;
  var
    idx: Integer;
  begin
    _enableEQ_addr^ := Ord(FEqualizerEnabled);
    _n_enableEQ_addr^ := 0;
    for idx := 0 to 31 do begin
      _equalizer_addr(idx)^ := Power(10, FEqualizer[idx]/100.0);
    end;
    if 0 < FSamplingRate then begin
      for idx := 0 to 31 do begin
        FEqualizerFreq[idx] := Round(FSamplingRate/64.0*(idx+0.5));
      end;
    end;
  end;

begin
  RemoveMessages(MPM_CHANGEEQUALIZER, MPM_CHANGEEQUALIZER);

  if not IsOpen then begin
    Exit;
  end;

  case EqualizerMode of
    memFreq: begin
      FreqMode;
    end;
    memSubBand: begin
      SubBandMode;
    end;
  end;
end;

procedure TMP3Player.MPMChangePosition(var Msg: TMessage);
begin
  RemoveMessages(MPM_CHANGEPOSITION, MPM_CHANGEPOSITION);
  ChangePosition(Self);
end;

procedure TMP3Player.MPMChangeStatus(var Msg: TMessage);
begin
  RemoveMessages(MPM_CHANGESTATUS, MPM_CHANGESTATUS);
  ChangeStatus(Self);
end;

procedure TMP3Player.MPMDecodeEnd(var Msg: TMessage);
begin
  FEndPlayReason := merSuccessful;
  if FReader.Seekable then begin
    Stop;
  end
  else begin
    Close;
  end;
end;

procedure TMP3Player.MPMDecodeError(var Msg: TMessage);
var
  e: Exception;
  event: TMPEvent;
begin
  e := Exception(Msg.LParam);
  event := TMPEvent(Msg.WParam);
  try
    if e <> nil then begin
      Application.ShowException(e);
    end;
  finally
    if event <> nil then begin
      event.SetEvent;
    end;
  end;

  FEndPlayReason := merFailure;
  Stop;
end;

procedure TMP3Player.MPMEndPlay(var Msg: TMessage);
begin
  RemoveMessages(MPM_ENDPLAY, MPM_ENDPLAY);
  EndPlay(Self);
end;

procedure TMP3Player.MPMWatchEvent(var Msg: TMessage);
var
  inOut: TInOut;
  wroteLen: Integer;
  header: TMpegHead;
  soundBufRate: Integer;

  procedure EOD;
  begin
    FBodyLength := FReader.Position-FBodyPos;
    Exit;
  end;

  procedure Retry;
  begin
    if MaxRetryBytes <= FRetryBytes then begin
      EOD;
    end
    else begin
      FReader.Skip(1);
      Inc(FRetryBytes);
    end;
  end;

begin
  FDecodeCS.Lock;
  try
    if FDecodeThread.WatchEvent.WaitFor(0) = WAIT_TIMEOUT then begin
      Exit;
    end;

    if FOutBufAvailableLen = 0 then begin

      if FBodyLength <= FReader.Position-FBodyPos then begin
        FSoundOutMutex.Lock;
        try
          FSoundOut.RequestEvent(nil);
          FSoundOut.Flush;
        finally
          FSoundOutMutex.Unlock;
        end;
        FSoundOut.WaitForEmpty;
        FDecodeThread.WatchEvent.ResetEvent;
        Self.PostMessage(MPM_DECODEEND, 0, 0);
        Exit;
      end;

      if FFrameBytes <= 0 then begin
        if not FReader.Fill(SizeOf(TMpegRawHead)) then begin
          EOD;
          Exit;
        end;
        FFrameBytes := GetFrameBytes(FReader.Buffer[0], header);
        if FFrameBytes <= 0 then begin
          Retry;
          Exit;
        end;
      end;

      if FNeedInitDecode then begin
        if InitLMC(header, FFrameBytes, 0,0,0, 24000) = 0 then begin
          Retry;
          Exit;
        end;
      end;

      if not FReader.Fill(FFrameBytes) then begin
        EOD;
        Exit;
      end;

      inOut := _audio_decode(FReader.Buffer[0], FOutBuf[0]);

      FReader.Skip(FFrameBytes);
      FFrameBytes := 0;
      FRetryBytes := 0;
      FOutBufAvailableLen := FOutFrameBytes;

      if inOut.InBytes <= 0 then begin
        FillChar(FOutBuf[0], FOutBufAvailableLen, 0);
      end;
    end;

    Assert(0 < FOutBufAvailableLen);

    FSoundOutMutex.Lock;
    try
      if FSoundOut.HasRoom then begin
        wroteLen := FSoundOut.Write(FOutBuf[0], FOutBufAvailableLen);
        Dec(FOutBufAvailableLen, wroteLen);
        Move(FOutBuf[wroteLen], FOutBuf[0], FOutBufAvailableLen);
      end
      else begin
        FDecodeThread.WatchEvent.ResetEvent;
        FSoundOut.RequestEvent(FDecodeThread.WatchEvent);
      end;
      soundBufRate := FSoundOut.BufRoomRate;
    finally
      FSoundOutMutex.Unlock;
    end;
  finally
    FDecodeCS.Unlock;
  end;

{$ifndef UseReadAhead}
  Assert(FReader.FStream <> nil, 'TMP3Player.MPMWatchEvent');
  while soundBufRate = 0 do begin
    FDecodeCS.Lock;
    try
      if FDecodeThread.WatchEvent.WaitFor(0) = WAIT_TIMEOUT then begin
        Break;
      end;
      Assert(FReader.FStream <> nil, 'TMP3Player.MPMWatchEvent');
      if not FReader.FillOnIdle then begin
        Break;
      end;
    finally
      FDecodeCS.Unlock;
    end;
    FSoundOutMutex.Lock;
    try
      soundBufRate := FSoundOut.BufRoomRate;
    finally
      FSoundOutMutex.Unlock;
    end;
  end;
{$endif}

  if soundBufRate <= 25 then begin
    Sleep(0);
  end;
end;


procedure TMP3Player.Open;
var
  openingFileName: TFileName;
begin
  if FFileName <> '' then begin
    openingFileName := FFileName;
    OpenStream(TFileStream.Create(FFileName, fmOpenRead or fmShareDenyWrite),
      [mstSeekable, mstOwn]);
    FFileName := openingFileName;
  end
  else begin
    Close;
  end;
end;

procedure TMP3Player.OpenStream(Stream: TStream; StreamType: TMP3StreamType);
var
  topPos: Cardinal;
  decInfo: TDecInfo;
begin
  try
    Close;
  except
    if (Stream <> nil) and (mstOwn in StreamType) then begin
      Stream.Free;
    end;
    raise;
  end;

  FStream := Stream;
  FStreamType := StreamType;

  if IsOpen then begin

    try
      FFramePosList.Clear;
{$ifdef UseReadAhead}
      FReadAheadStream.Open(FStream);
      FReader.Open(FReadAheadStream, mstSeekable in FStreamType);
{$else}
      FReader.Open(FStream, mstSeekable in FStreamType);
{$endif}
      GetMemAlign(FOutBuf, OutBufSize, 8);

      FInfo.SetReader(FReader);

      if FReader.Seekable then begin
        FBodyPos := 0;
        FBodyLength := FReader.Size;
        FOutputBytes := 0;

        FInfo.ReadHead;
        FInfo.ReadTail;

        FReader.Seek(FInfo.FBodyPos, soFromBeginning);
      end
      else begin
        FBodyPos := 0;
        FBodyLength := MaxInt;

        FInfo.ReadHead;
      end;
      FBodyPos := FInfo.FBodyPos;
      FBodyLength := FInfo.FBodyLength;


      FOutBufAvailableLen := 0;
      FPCMDoneOutBytes := 0;
      FPosition := 0;

      FReader.Fill(MaxRetryBytes);

      if _head_info3(FReader.Buffer[0], FReader.AvailableBytes, FFirstHeader,
        FBitRate, topPos) <= 0 then begin
        raise EMP3Error.Create(SInvalidMP3Format);
      end;

      if 0 < topPos then begin
        Inc(FBodyPos, topPos);
        if FBodyLength < MaxInt then begin
          Dec(FBodyLength, topPos);
        end;
        if not FReader.Skip(topPos) then begin
          raise EMP3Error.Create(SInvalidMP3Format);
        end;
        FReader.Fill(MaxFrameBytes);
        if FReader.AvailableBytes < SizeOf(FFirstRawHead) then begin
          raise EMP3Error.Create(SInvalidMP3Format);
        end;
      end;
      Move(FReader.Buffer[0], FFirstRawHead, SizeOf(FFirstRawHead));
      FFrameBytes := GetFrameBytes(FReader.Buffer[0], FFirstHeader);
      if (FFrameBytes <= 0) or not(FFirstHeader.Option in [1, 2, 3]) then begin
        raise EMP3Error.Create(SInvalidMP3Format);
      end;

      case FFirstHeader.Option of
        1: begin
          FLayer := 3;
        end;
        2: begin
          FLayer := 2;
        end;
        3: begin
          FLayer := 1;
        end;
      else
        raise EMP3Error.Create(SInvalidMP3Format);
      end;
      case FFirstHeader.ID of
        0: begin
          case FFirstHeader.Sync of
            1: begin
              FVersion := 2;
            end;
            2: begin
              FVersion := 3;
            end;
          else
            raise EMP3Error.Create(SInvalidMP3Format);
          end;
        end;
        1: begin
          FVersion := 1;
        end;
      else
        raise EMP3Error.Create(SInvalidMP3Format);
      end;
      if not FReader.Fill(FFrameBytes) then begin
        raise EMP3Error.Create(SInvalidMP3Format);
      end;

      if InitLMC(FFirstHeader, FFrameBytes, 0,0,0, 24000) = 0 then begin
        raise EMP3Error.Create(SInvalidMP3Format);
      end;

      _audio_decode_info(decInfo);

      with FSoundOut do begin
        SamplingRate := decInfo.Samprate;
        BitsPerSample := decInfo.Bits;
        Channels := decInfo.Channels;
      end;

      FSamplingRate := decInfo.Samprate;
      FChannels := decInfo.Channels;
      FOutFrameBytes := decInfo.Outvalues*decInfo.Bits div 8;

      ReadVBRHeader;

      FFramePosList.Add(Pointer(FReader.Position));

    except
      Close;
      raise;
    end;
    PostUniqMessage(MPM_CHANGEEQUALIZER, 0, 0);
    SetStatus(mstStop);
  end;

  if FAutoPlay then begin
    Play;
  end;
end;

procedure TMP3Player.Pause;
begin
  if mcbCanPause in Capabilities then begin
    FSoundOutMutex.Lock;
    try
      FSoundOut.Pause;
    finally
      FSoundOutMutex.Unlock;
    end;
    SetStatus(mstPause);
  end;
end;

procedure TMP3Player.PCMDoneOutput(Sender: TObject);
begin
  PostMessage(MPM_CHANGEPOSITION, 0, 0);
end;

procedure TMP3Player.UpdatePosition;
begin
  FSoundOutMutex.Lock;
  try
    with FSoundOut do begin
      if IsOpen then begin
        Inc(FPCMDoneOutBytes, GetDoneBytes );
        FPosition := Int64(FPCMDoneOutBytes)*1000*8 div (SamplingRate*Channels*BitsPerSample);
      end;
    end;
  finally
    FSoundOutMutex.Unlock;
  end;
end;

procedure TMP3Player.Play;
var
  caps: Integer;
begin
  if mcbCanPlay in Capabilities then begin

    try
      caps := CPUSpecs and (not CpuCapabilitiesToCpuCaps(MccAll)) or
              CpuCapabilitiesToCpuCaps(FUsingCpuCapabilities);
      _set_cpu_caps(caps);

      FSoundOutMutex.Lock;
      try
        with FSoundOut do begin
          OnDoneOutput := Self.PCMDoneOutput;
          WaveFileName := Self.FOutputFileName;
          DeviceID     := Self.FDeviceID;
          Open;
        end;
      finally
        FSoundOutMutex.Unlock;
      end;
      FDecodeThread.WatchEvent.SetEvent;
    except
      Stop;
      raise;
    end;

    SetStatus(mstPlay);
    FEndPlayReason := merStoped;
    PostUniqMessage(MPM_CHANGEPOSITION, 0, 0);
  end;
end;


procedure TMP3Player.PlayToFile(FileName: TFileName);
begin
  if mcbCanPlayToFile in Capabilities then begin
    FOutputFileName := FileName;
    Play;
  end;
end;

procedure TMP3Player.PostMessage(Msg: UINT; wParam: WPARAM; lParam: LPARAM);
begin
  if FWindowHandle <> 0 then begin
    Windows.PostMessage(FWindowHandle, Msg, WParam, LParam);
  end;
end;

procedure TMP3Player.PostUniqMessage(Msg: UINT; wParam: WPARAM;
  lParam: LPARAM);
var
  message: TMsg;
begin
  if FWindowHandle <> 0 then begin
    if not PeekMessage(message, FWindowHandle, Msg, Msg, PM_NOREMOVE) then begin
      Windows.PostMessage(FWindowHandle, Msg, WParam, LParam);
    end;
  end;
end;

class function TMP3Player.QueryOpen(const FileName: TFileName): Boolean;
var
  info: TMP3Info;
begin
  Result := False;
  try
    info := TMP3Info.Create;
    try
      info.ReadFromFile(FileName);
    finally
      info.Free;
    end;
    Result := True;
  except
    on EMP3Error do begin
    end;
  end;
end;


class procedure TMP3Player.ReadInfo(const FileName: TFileName;
  Info: TMP3Info);
begin
  info.ReadFromFile(FileName);
end;


const
  XingVbrFramesFlag = $1;
  XingVbrBytesFlag = $2;
  XingVbrTocFlag = $4;
  XingVbrScaleFlag = $8;

procedure TMP3Player.ReadVBRHeader;
var
  vbrPos: Integer;
  xingFlags: Integer;
  vbrFlameCount: Integer;
begin
  //  require
  //  FReader f[^{̂̑1t[擪Ă邱
  //  Open Ă FStream Ɋ FOutFrameBytes, FFirstHeader 
  //  ݒ肳Ă邱
  Assert(IsOpen);

  vbrPos := 0;
  if FFirstHeader.Prot = 0 then begin
    Inc(vbrPos, 2);
  end;
  case FFirstHeader.ID of
    0: begin  //  MPEG 2 or 2.5
      if FFirstHeader.Mode <> 3 then begin
        Inc(vbrPos, 21);
      end
      else begin
        Inc(vbrPos, 13);
      end;
    end;
    1: begin  //  MPEG 1
      if FFirstHeader.Mode <> 3 then begin
        Inc(vbrPos, 36);
      end
      else begin
        Inc(vbrPos, 21);
      end;
    end;
  end;
  if StrLComp(@(FReader.Buffer[vbrPos]), 'Xing', 4) = 0 then begin
    FBitRate := 0;
    Inc(vbrPos, 4);

    xingFlags := ReadBigEndianInt(FReader.Buffer[vbrPos]);
    Inc(vbrPos, 4);

    if (xingFlags and XingVbrFramesFlag) <> 0 then begin
      vbrFlameCount := ReadBigEndianInt(FReader.Buffer[vbrPos]);
      if 0 < vbrFlameCount then begin
        FOutputBytes := (vbrFlameCount-1)*FOutFrameBytes;
      end;
      Inc(vbrPos, 4);
    end;

    if (xingFlags and XingVbrBytesFlag) <> 0 then begin
      if 0 < ReadBigEndianInt(FReader.Buffer[vbrPos]) then begin
        FBodyLength := ReadBigEndianInt(FReader.Buffer[vbrPos]);
      end;
//          Inc(vbrPos, 4);
    end;
    if not FReader.Skip(FFrameBytes) then begin
      raise EMP3Error.Create(SInvalidMP3Format);
    end;

    Inc(FBodyPos, FFrameBytes);
    if FBodyLength < MaxInt then begin
      Dec(FBodyLength, FFrameBytes);
    end;

    FFrameBytes := 0;
  end
  else if StrLComp(@(FReader.Buffer[vbrPos]), 'VBRI', 4) = 0 then begin
    FBitRate := 0;
    Inc(vbrPos, 10);

    if 0 < ReadBigEndianInt(FReader.Buffer[vbrPos]) then begin
      FBodyLength := ReadBigEndianInt(FReader.Buffer[vbrPos]);
    end;
    Inc(vbrPos, 4);

    vbrFlameCount := ReadBigEndianInt(FReader.Buffer[vbrPos]);
    if 0 < vbrFlameCount then begin
      FOutputBytes := (vbrFlameCount-1)*FOutFrameBytes;
    end;

    if not FReader.Skip(FFrameBytes) then begin
      raise EMP3Error.Create(SInvalidMP3Format);
    end;

    Inc(FBodyPos, FFrameBytes);
    if FBodyLength < MaxInt then begin
      Dec(FBodyLength, FFrameBytes);
    end;

    FFrameBytes := 0;
  end;

  //  ensure
  //  Xing `܂ VBRI ` VBR wb_[Awb_[eɊ
  //  FBodyLength, FOutputBytes ݒ肵AFReader  2Ԃ߂̃t[w悤
  //  ɂ
  //  VBR wb_[Ȃ΁AȂɂȂ
end;

procedure TMP3Player.ResetDecode;
begin
  FOutBufAvailableLen := 0;
  FFrameBytes := 0;
  FPCMDoneOutBytes := 0;
  FPosition := 0;
end;

procedure TMP3Player.RemoveMessages(MsgFilterMin, MsgFilterMax: UINT);
var
  msg: TMsg;
begin
  Assert(MsgFilterMin <= MsgFilterMax);

  if FWindowHandle <> 0 then begin
    while PeekMessage(msg, FWindowHandle, MsgFilterMin, MsgFilterMax,
      PM_REMOVE) do begin
    end;
  end;
end;

procedure TMP3Player.Seek(NewPosition: Integer);
var
  aimPCMOutSize: int64;
  aimFrameIdx: int64;
  pausing: Boolean;
  frames: TList;
  curSyncPos: Integer;
  retryBytes: Integer;

  procedure Retry;
  begin
    FReader.Skip(1);
    Inc(retryBytes);
  end;


  function SkipFrame: Boolean;
  var
    header: TMpegHead;
    frameBytes: Integer;
  begin
    Result := False;

    retryBytes := 0;

    while retryBytes < MaxRetryBytes do begin

      if not FReader.Fill(SizeOf(TMpegRawHead)) then begin
        Exit;
      end;

      frameBytes := GetFrameBytes(FReader.Buffer[0], header);
      if frameBytes <= 0 then begin
        Retry;
        Continue;
      end;

      if int64(FBodyPos)+FBodyLength < FReader.Position+frameBytes then begin
        Exit;
      end;

      if not FReader.Skip(frameBytes) then begin
        Exit;
      end;

      Result := True;
      Exit;
    end;
  end;

begin
  Assert(FReader.Seekable);
  if (0 <= NewPosition) and (mcbCanSeek in Capabilities) then begin
    FDecodeCS.Lock;
    FSoundOutMutex.Lock;
    try
      FSoundOut.OnDoneOutput := nil;
      pausing := FStatus = mstPause;
      FSoundOut.Stop;
      FSoundOut.WaitForEmpty;
      ResetDecode;
      if not FNoisySeek then begin
        FNeedInitDecode := True;
      end;

      aimPCMOutSize := Int64(NewPosition)*FSamplingRate*FChannels*2 div 1000;
      aimFrameIdx := (aimPCMOutSize+FOutFrameBytes-1) div FOutFrameBytes;
      if MaxInt < aimFrameIdx then begin
        aimFrameIdx := MaxInt;
      end;

      frames := FFramePosList.LockList;
      try
        if frames.Count <= aimFrameIdx then begin
          FReader.Seek(Integer(frames[frames.Count-1]), soFromBeginning);
          if not SkipFrame then begin
            aimFrameIdx := frames.Count-1;
          end
          else begin
            while frames.Count <= aimFrameIdx do begin

              curSyncPos := FReader.Position;

              if not SkipFrame then begin
                aimFrameIdx := frames.Count-1;
                Break;
              end;

              frames.Add(Pointer(curSyncPos));
            end;
          end;
        end;

        FReader.Seek(Integer(frames[aimFrameIdx]), soFromBeginning);
        FPCMDoneOutBytes := aimFrameIdx*FOutFrameBytes;
      finally
        FFramePosList.UnlockList;
      end;

      if pausing then begin
        FSoundOut.Pause;
      end;
      FSoundOut.OnDoneOutput := Self.PCMDoneOutput;
    finally
      FSoundOutMutex.Unlock;
      FDecodeCS.Unlock;
    end;

    PostUniqMessage(MPM_CHANGEPOSITION, 0, 0);
  end;
end;

procedure TMP3Player.SetAutoOpen(const Value: Boolean);
begin
  FAutoOpen := Value;
  if FAutoOpen and not(csDesigning in ComponentState) and
    not(csLoading in ComponentState) then begin
    Open;
  end;
end;

procedure TMP3Player.SetAutoPlay(const Value: Boolean);
begin
  FAutoPlay := Value;
  if IsOpen and (FStatus in [mstStop, mstPause]) then begin
    Play;
  end;
end;

procedure TMP3Player.SetChangePosStep(const Value: Integer);
begin
  if 100 <= Value then begin
    FChangePosStep := Value;
    FSoundOutMutex.Lock;
    try
      FSoundOut.DoneOutputStep := Value;
    finally
      FSoundOutMutex.Unlock;
    end;
  end;
end;

procedure TMP3Player.SetDecodePriority(const Value: TThreadPriority);
const
  priorities: array [TThreadPriority] of Integer =
   (THREAD_PRIORITY_IDLE, THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL,
    THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL,
    THREAD_PRIORITY_HIGHEST, THREAD_PRIORITY_TIME_CRITICAL);
begin
  FDecodePriority := Value;
  if not(csDesigning in  ComponentState) then begin
    FDecodeThread.Priority := priorities[FDecodePriority];
  end;
end;

procedure TMP3Player.SetDeviceID(const Value: DWord);
begin
  if (Value = WAVE_MAPPER) or (Value < DWord(DeviceCount)) then begin
    FDeviceID := Value;
  end;
end;

procedure TMP3Player.SetEqualizer(Index: Integer; const Value: Integer);
begin
  if (Index < 0) or (32 <= Index) then begin
    raise EListError.CreateFmt(SListIndexError, [Index]);
  end;

  if (-100.0 <= Value) and (Value <= 100.0) then begin
    FEqualizer[Index] := Value;
    PostUniqMessage(MPM_CHANGEEQUALIZER, 0,0);
  end;
end;

procedure TMP3Player.SetEqualizerCount(const Value: Integer);
begin
  if (0 < Value) and (Value <> FEqualizerCount) then begin
    FEqualizerCount := Value;
    PostUniqMessage(MPM_CHANGEEQUALIZER, 0, 0);
  end;
end;

procedure TMP3Player.SetEqualizerEnabled(const Value: Boolean);
begin
  if Value <> FEqualizerEnabled then begin
    FEqualizerEnabled := Value;
    PostUniqMessage(MPM_CHANGEEQUALIZER, 0, 0);
  end;
end;

procedure TMP3Player.SetEqualizerFreq(Index: Integer;
  const Value: Integer);
begin
  if (Index < 0) or (32 <= Index) then begin
    raise EListError.CreateFmt(SListIndexError, [Index]);
  end;

  if (FEqualizerMode = memFreq) and
    (1 <= Value) and (Value <= 24000) then begin
    FEqualizerFreq[Index] := Value;
    PostUniqMessage(MPM_CHANGEEQUALIZER, 0, 0);
  end;
end;

procedure TMP3Player.SetEqualizerFreqs(MinFreq, MaxFreq: Integer);
var
  freqIdx: Integer;
begin
  if (FEqualizerMode = memFreq) and
    (1 <= MinFreq) and (MinFreq <= MaxFreq) and (MaxFreq <= 24000) then begin

    FEqualizerFreq[0] := MinFreq;
    for freqIdx := 1 to FEqualizerCount-2 do begin
      FEqualizerFreq[freqIdx] :=
        Round(
          FEqualizerFreq[freqIdx-1]*
          Power(1.0*MaxFreq/FEqualizerFreq[freqIdx-1],
            1.0/(FEqualizerCount-freqIdx)));
      Assert(FEqualizerFreq[freqIdx-1] <= FEqualizerFreq[freqIdx]);
    end;
    FEqualizerFreq[FEqualizerCount-1] := MaxFreq;

    PostUniqMessage(MPM_CHANGEEQUALIZER, 0, 0);
  end;
end;

procedure TMP3Player.SetEqualizerMode(const Value: TMP3EqualizerMode);
begin
  if FEqualizerMode <> Value then begin
    FEqualizerMode := Value;
    PostUniqMessage(MPM_CHANGEEQUALIZER, 0, 0);
  end;
end;

procedure TMP3Player.SetFileName(const Value: TFileName);
begin
  FFileName := Value;
  if FAutoOpen and not(csDesigning in ComponentState) and
    not(csLoading in ComponentState) then begin
    Open;
  end;
end;

procedure TMP3Player.SetNeedInfoType(const Value: TMP3InfoType);
begin
  FInfo.NeedInfoType := Value;
end;

procedure TMP3Player.SetInvertPolarity(const Value: Boolean);
begin
  FDecodeCS.Lock;
  try
    _set_invert_polarity(Ord(Value));
  finally
    FDecodeCS.Unlock;
  end;
end;

procedure TMP3Player.SetStatus(Value: TMP3Status);
var
  needEndPlayEvent: Boolean;
begin
  needEndPlayEvent := IsOpen and
    (FStatus in [mstPlay, mstPause]) and (Value = mstStop);
  FStatus := Value;
  PostUniqMessage(MPM_CHANGESTATUS, 0, 0);
  if needEndPlayEvent then begin
    PostUniqMessage(MPM_ENDPLAY, 0, 0);
  end;
end;

procedure TMP3Player.SetUsingCpuCapabilities(const Value: TMP3CpuCapabilities);
begin
{$ifdef ASM_X86}
  if not(csDesigning in ComponentState) then begin
    FUsingCpuCapabilities := Value * CpuCapsToCpuCapabilities(CPUSpecs);
  end
  else begin
    FUsingCpuCapabilities := Value * mccALL;
  end;
{$endif}
end;

procedure TMP3Player.SetVolBalance(const Value: Integer);
begin
  if (-100 <= Value) and (Value <= 100) then begin
    FVolBalance := Value;
    FSoundOutMutex.Lock;
    try
      FSoundOut.VolBalance := FVolBalance;
    finally
      FSoundOutMutex.Unlock;
    end;
  end;
end;

procedure TMP3Player.SetVolume(const Value: Integer);
begin
  if Value in [0..100] then begin
    if (Value = 0) and
      (csLoading in ComponentState) and
      not(csDesigning in ComponentState) then begin
      FSoundOutMutex.Lock;
      try
        FVolume := FSoundOut.Volume;
      finally
        FSoundOutMutex.Unlock;
      end;
    end
    else begin
      FVolume := Value;
      FSoundOutMutex.Lock;
      try
        FSoundOut.Volume := FVolume;
      finally
        FSoundOutMutex.Unlock;
      end;
    end;
  end;
end;

procedure TMP3Player.Stop;
begin
  if (not IsOpen) or (FStatus = mstStop) then begin
    Exit;
  end;

  FOutputFileName := '';
  FDecodeCS.Lock;
  FSoundOutMutex.Lock;
  try
    with FSoundOut do begin
      OnDoneOutput := nil;
      Stop;
      Close;
    end;
    FDecodeThread.WatchEvent.ResetEvent;
  finally
    FSoundOutMutex.Unlock;
    FDecodeCS.Unlock;
  end;

  if IsOpen and FReader.Seekable then begin
    FReader.Seek(FBodyPos, soFromBeginning);
  end;

  ResetDecode;
  FNeedInitDecode := True;

  SetStatus(mstStop);
  PostUniqMessage(MPM_CHANGEPOSITION, 0, 0);

  if IsOpen and not(FReader.Seekable) then begin
    Close;
  end;
end;

procedure TMP3Player.ThreadError(Sender: TObject; E: Exception;
  var Handled: Boolean);
var
  event: TMPEvent;
begin
  event := TMPSimpleEvent.Create;
  try
    PostMessage(MPM_DECODEERROR, DWORD(event), DWORD(E));
    event.WaitFor(INFINITE);
    Handled := True;
  finally
    event.Free;
  end;
end;

procedure TMP3Player.Unpause;
begin
  if mcbCanUnpause in Capabilities then begin
    FSoundOutMutex.Lock;
    try
      FSoundOut.Unpause;
    finally
      FSoundOutMutex.Unlock;
    end;
    SetStatus(mstPlay);
  end;
end;

procedure TMP3Player.WndProc(var Message: Tmessage);
begin
  case Message.Msg of
    MPM_FIRST..MPM_LAST: begin
      if Message.Msg = MPM_CHANGEPOSITION then begin
        Application.ProcessMessages;
      end;
      Dispatch(Message);
    end;
  else
    case Message.Msg of
      //  ̊ԈႢŐɔ\ Window j鎞ł
      //  foCXȂǂĂ
      WM_DESTROY, WM_ENDSESSION: begin
        Close;
      end;
    end;
    with Message do begin
      Result := DefWindowProc(FWindowHandle, Msg, wParam, lParam);
    end;
  end;
end;



end.

