;/*
; *  for MP3Player - Free Delphi Component (OCT. 1999)
; *  modified by Kei Ishida  kei-i@sams.co.jp
; */

;/*
; * mdct.c ASM version for the XingMPG Decoder
; * Include hybrid and FreqInvert functions
; *
; * Copyright (c) 1999, Jean-Michel HERVE
; *
; * This is hardcore coding, really! But should work pedity fine. If you find
; * a bug mmmmh... tell me where :)
; *
; * Code : TuO / StG
; * Date : 05/04/99
; *
; * This program is free software; you can redistribute it and/or modify
; * it under the terms of the GNU General Public License as published by
; * the Free Software Foundation; either version 2 of the License, or
; * (at your option) any later version.
; * 
; * This program is distributed in the hope that it will be useful,
; * but WITHOUT ANY WARRANTY; without even the implied warranty of
; * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; * GNU General Public License for more details.
; * 
; * You should have received a copy of the GNU General Public License
; * along with this program; if not, write to the Free Software
; * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
; * 
; * $Id: mdctasm.asm,v 1.3 1999/04/22 08:24:01 mhw Exp $
; */

%include "nasm.h"

segment_data

EXTERN _mdct18w
EXTERN _mdct18w2
EXTERN _mdct6_3v
EXTERN _mdct6_3v2
EXTERN _coef
EXTERN _coef87
EXTERN _win
EXTERN _band_limit_nsb

WINSIZE equ 144

My_FPU_Half dd 0.5

%macro div18 0
;   eax/18  edx ɕԂ
;   input   eax
;   output  edx
    mov edx,3817748708
    mul edx
    shr edx,4
%endmacro

%macro div36 0
;   eax/36  edx ɕԂ
;   input   eax
;   output  edx
    mov edx,3817748708
    mul edx
    shr edx,5
%endmacro

%idefine    a(p)        [sp(%$tab_a)+(p)*4]
%idefine    b(p)        [sp(%$tab_b)+(p)*4]
%idefine    mdct18w(p)  [_mdct18w+(p)*4]
%idefine    mdct18w2(p) [_mdct18w2+(p)*4]
%idefine    coef(i,j)   [_coef+(i)*16+(j)*4]
%idefine    f(p)        [edi+(p)*4]

proc imdct18_inner_p5
; void imdct18(float f[18]) ̉
;   input   edi     f[18]
;   uses    none

%$tab_a local   9*4
%$tab_b local   9*4
        alloc

;/* Unroll the loop because it is a known-value count */
%assign p 0                            ;/* Use compiler var as counter */
%rep 4
        fld     dword mdct18w(p)            
        fmul    dword f(p)                  
        fld     dword mdct18w(17-p) 
        fmul    dword f(17-p)
        fld     dword mdct18w(8-p)          
        fmul    dword f(8-p)                
        fld     dword mdct18w(9+p)          
        fmul    dword f(9+p)                ; g2' g1' g2 g1
        fld     st3
        fsub    st3                         ; g1-g2 g2' g1' g2 g1
        fld     st2
        fsub    st2                         ; g1'-g2' g1-g2 g2' g1' g2 g1
        fxch    st1
        fmul    dword mdct18w2(p)           ; bp g1'-g2' g2' g1' g2 g1
        fxch    st5
        faddp   st4,st0                     ; g1'-g2' g2' g1' ap bp
        fmul    dword mdct18w2(8-p)         ; b8p  g2' g1' ap bp
        fxch    st2
        faddp   st1,st0                     ; a8p b8p ap bp
        fld     st3
        fadd    st2                         ; b[p] a8p b8p ap bp
        fld     st3
        fadd    st2                         ; a[p] b[p] a8p b8p ap bp
        fxch    st3
        fsubp   st5,st0                     ; b[p] a8p a[p] ap b[5+p]
        fstp    dword b(p)                  ; a8p a[p] ap b[5+p]
        fsubp   st2,st0                     ; a[p] a[5+p] b[5+p]
        fstp    dword a(p)                  ; a[5+p] b[5+p]
        fxch    st1
        fstp    dword b(5+p)
        fstp    dword a(5+p)
%assign p p+1
%endrep

%assign p 4
        ;/* Last - finalize array */
        fld     dword mdct18w(p)
        fmul    dword f(p)
        fld     dword mdct18w(17-p)
        fmul    dword f(17-p)
        fld     st1
        fsub    st1                     ; g1-g2 g2 g1
        fxch    st2
        faddp   st1,st0                 ; ap g1-g2
        fxch    st1
        fmul    dword mdct18w2(p)       ; bp ap
        fxch    st1
        fst     dword a(p)
        fxch    st1
        fst     dword b(p)              ; b(4) a(4)

        fld     dword a(0)
        fadd    dword a(1)
        fld     dword b(0)
        fadd    dword b(1)
        fld     dword a(2)
        fadd    dword a(3)
        fld     dword b(2)
        fadd    dword b(3)              ; b(2)+b(3) a(2)+a(3) b(0)+b(1) a(0)+a(1) b(4) a(4)
        fxch    st3
        faddp   st1,st0                 ; a(0)+a(1)+a(2)+a(3) b(0)+b(1) b(2)+b(3) b(4) a(4)
        fxch    st1
        faddp   st2,st0                 ; a(0)+a(1)+a(2)+a(3) b(0)+b(1)+b(2)+b(3) b(4) a(4)
        faddp   st3,st0
        faddp   st1,st0
        fxch    st1
        fmul    dword [My_FPU_Half]
        fxch    st1
        fmul    dword [My_FPU_Half]
        fxch    st1
        fst     dword f(0)
        fxch    st1

        fld     dword coef(1,0)
        fmul    dword a(5)
        fld     dword coef(1,1)
        fmul    dword a(6)
        fld     dword coef(1,2)     
        fmul    dword a(7)          
        fld     dword coef(1,3)     
        fmul    dword a(8)          
        fxch    st3                 
        faddp   st1,st0             
        fxch    st2
        faddp   st1,st0
        fld     dword coef(1,0)
        fmul    dword b(5)
        fxch    st1
        faddp   st2,st0                     ; v5 f2' f1' f0
        fld     dword coef(1,1)
        fmul    dword b(6)
        fld     dword coef(1,2)
        fmul    dword b(7)
        fld     dword coef(1,3)
        fmul    dword b(8)
        fxch    st3
        faddp   st1,st0                     ; v5+v7 v6 v8 f2' f1' f0
        fxch    st2
        faddp   st1,st0                     ; v6+v8 v5+v7 f2' f1' f0
        fxch    st4
        fsubr   st3                         ; f1 v5+v7 f2' f1' v6+v8
        fxch    st4
        faddp   st1,st0                     ; f3'' f2' f1' f1
        fld     dword coef(2,0)
        fmul    dword a(0)                  ; v0 f3'' f2' f1' f1
        fxch    st1                         ; f3'' v0 f2' f1' f1
        fsubrp  st3,st0                     ; v0 f2' f3' f1
        fxch    st1                         ; f2' v0 f3' f1
        fsub    st3                         ; f2 v0 f3' f1
        fxch    st3                         ; f1 v0 f3' f2
        fstp    dword f(1)                  ; v0 f3' f2
        fxch    st2                         ; f2 f3' v0
        fst     dword f(2)
        fxch    st2                         ; v0 f3' f2

        fld     dword coef(2,1)
        fmul    dword a(1)
        fld     dword coef(2,2)
        fmul    dword a(2)
        fld     dword coef(2,3)
        fmul    dword a(3)
        fxch    st3                 
        faddp   st1,st0             
        fxch    st2
        faddp   st1,st0
        fld     dword coef(2,0)
        fmul    dword b(0)
        fxch    st1
        faddp   st2,st0                     ; v0 f4'' f3' f2
        fld     dword coef(2,1)
        fmul    dword b(1)                  ; v1 v0 f4'' f3' f2
        fxch    st2
        fsub    dword a(4)                  ; f4' v0 v1 f3' f2
        fxch    st2
        fld     dword coef(2,2)
        fmul    dword b(2)
        fld     dword coef(2,3)
        fmul    dword b(3)                  ; v3 v2 v1 v0 f4' f3' f2
        fxch    st3
        fsub    dword b(4)
        fxch    st2
        faddp   st1,st0                     
        fxch    st2
        faddp   st1,st0                     
        fxch    st4
        fsubr   st3                         
        fxch    st4
        faddp   st1,st0                     
        fld     dword a(5)
        fsub    dword a(7)
        fxch    st1                         
        fsubrp  st3,st0                     
        fxch    st1                         
        fsub    st3                         
        fxch    st3                         
        fstp    dword f(3)                  
        fxch    st2                         
        fst     dword f(4)
        fxch    st2                         ; a(5)-a(7) f5' f4

        fsub    dword a(8)
        fld     dword b(5)
        fsub    dword b(7)
        fxch    st1                         
        fmul    dword coef(3,0)             ; f6' b(5)-b(7) f5' f4
        fxch    st3                         ; f4 b(5)-b(7) f5' f6'
        fsubr   st2                         ; f5 b(5)-b(7) f5' f6'
        fxch    st1
        fsub    dword b(8)                  ; b(5)-b(7)-b(8) f5 f5' f6'
        fxch    st3                         ; f6' f5 f5' b(5)-b(7)-b(8)
        fsub    st1                         ; f6 f5 f5' b(5)-b(7)-b(8)
        fxch    st3                         ; b(5)-b(7)-b(8) f5 f5' f6
        fmul    dword coef(3,0)             ; f7'' f5 f5' f6
        fxch    st1
        fstp    dword f(5)                  ; f7'' f5' f6
        fxch    st2                         ; f6 f5' f7''
        fst     dword f(6)              
        fxch    st2                         ; f7'' f5' f6
        fsubrp  st1,st0                     ; f7' f6

        fld     dword coef(4,0)
        fmul    dword a(0)
        fld     dword coef(4,1)
        fmul    dword a(1)
        fld     dword coef(4,2)     
        fmul    dword a(2)          
        fld     dword coef(4,3)     
        fmul    dword a(3)          
        fxch    st3                 
        faddp   st1,st0             
        fxch    st2
        faddp   st1,st0
        fld     dword coef(4,0)
        fmul    dword b(0)
        fxch    st1
        faddp   st2,st0                     ; vb0 va0+va1+va2+va3 f7' f6
        fld     dword coef(4,1)
        fmul    dword b(1)                  ; vb1 vb0 va0+va1+va2+va3 f7' f6
        fxch    st2
        fadd    dword a(4)                  ; f8' vb0 vb1 f7' f6
        fld     dword coef(4,2)
        fmul    dword b(2)
        fld     dword coef(4,3)
        fmul    dword b(3)                  ; vb3 vb2 f8' vb0 vb1 f7' f6
        fxch    st3
        faddp   st1,st0                     ; vb0+vb2 f8' vb3 vb1 f7' f6
        fxch    st3
        faddp   st2,st0                     ; f8' vb3+vb1 vb0+vb2 f7' f6
        fxch    st4
        fsubr   st3                         ; f7 vb3+vb1 vb0+vb2 f7' f8'
        fxch    st2
        faddp   st1,st0                     ; vb3+vb1+vb0+vb2 f7 f7' f8'
        fxch    st3                         
        fsub    st1                         ; f8 f7 f7' vb3+vb1+vb0+vb2
        fxch    st1
        fstp    dword f(7)                  ; f8 f7' vb3+vb1+vb0+vb2
        fxch    st2     
        fadd    dword b(4)                  ; f9'' f7' f8
        fxch    st2
        fst     dword f(8)                  
        fxch    st2                         ; f9'' f7' f8
        fsubrp  st1,st0                     ; f9' f8

        fld     dword coef(5,0)
        fmul    dword a(5)
        fld     dword coef(5,1)
        fmul    dword a(6)
        fld     dword coef(5,2)     
        fmul    dword a(7)          
        fld     dword coef(5,3)     
        fmul    dword a(8)          
        fxch    st3                 
        faddp   st1,st0             
        fxch    st2
        faddp   st1,st0
        fld     dword coef(5,0)
        fmul    dword b(5)
        fxch    st1
        faddp   st2,st0                     
        fld     dword coef(5,1)
        fmul    dword b(6)
        fld     dword coef(5,2)
        fmul    dword b(7)
        fld     dword coef(5,3)
        fmul    dword b(8)
        fxch    st3
        faddp   st1,st0                     ; v5+v7 v6 v8 f10' f9' f8
        fxch    st2
        faddp   st1,st0                     ; v6+v8 v5+v7 f10' f9' f8
        fxch    st4
        fsubr   st3                         ; f9 v5+v7 f10' f9' v6+v8
        fxch    st4
        faddp   st1,st0                     ; f11'' f10' f9' f9
        fxch    st1                         ; f10' f11'' f9' f9
        fsub    st3                         ; f10 f11'' f9' f9
        fxch    st3
        fstp    dword f(9)                  ; f11'' f9' f10
        fsubrp  st1,st0                     ; f11' f10
        fxch    st1
        fst     dword f(10)
        fxch    st1

        fld     dword a(0)
        fadd    dword a(2)
        fld     dword b(0)
        fadd    dword b(2)
        fxch    st1
        fadd    dword a(3)              ; a0+a2+a3 b0+b2 f11' f10
        fld     dword a(1)
        fadd    dword a(4)              ; a1+a4 a0+a2+a3 b0+b2 f11' f10
        fxch    st1
        fmul    dword [My_FPU_Half]     ; 0.5*(a0+a2+a3) a1+a4 b0+b2 f11' f10
        fxch    st2
        fadd    dword b(3)              ; b0+b2+b3 a1+a4 0.5*(a0+a2+a3) f11' f10
        fld     dword b(1)
        fadd    dword b(4)              ; b1+b4 b0+b2+b3 a1+a4 0.5*(a0+a2+a3) f11' f10
        fxch    st1
        fmul    dword [My_FPU_Half]     ; 0.5*(b0+b2+b3) b1+b4 a1+a4 0.5*(a0+a2+a3) f11' f10
        fxch    st3
        fsubrp  st2,st0                 ; b1+b4 f12' 0.5*(b0+b2+b3) f11' f10
        fxch    st4                     
        fsubr   st3                     ; f11  f12' 0.5*(b0+b2+b3) f11' b1+b4
        fxch    st2
        fsubrp  st4,st0                 ; f12' f11 f11' f13''
        fsub    st1                     ; f12 f11 f11' f13''
        fxch    st2
        fsubp   st3,st0                 ; f11 f12 f13'
        fstp    dword f(11)             
        fst     dword f(12)
        fxch    st1

        fld     dword coef(7,0)
        fmul    dword a(5)
        fld     dword coef(7,1)
        fmul    dword a(6)
        fld     dword coef(7,2)     
        fmul    dword a(7)          
        fld     dword coef(7,3)     
        fmul    dword a(8)          
        fxch    st3                 
        faddp   st1,st0             
        fxch    st2
        faddp   st1,st0
        fld     dword coef(7,0)
        fmul    dword b(5)
        fxch    st1
        faddp   st2,st0                     
        fld     dword coef(7,1)
        fmul    dword b(6)
        fld     dword coef(7,2)
        fmul    dword b(7)
        fld     dword coef(7,3)
        fmul    dword b(8)
        fxch    st3
        faddp   st1,st0   
        fxch    st2
        faddp   st1,st0   
        fxch    st4
        fsubr   st3       
        fxch    st4
        faddp   st1,st0   
        fxch    st1     
        fsub    st3     
        fxch    st3
        fstp    dword f(13)
        fsubrp  st1,st0 
        fxch    st1
        fst     dword f(14)
        fxch    st1                     ; f15' f14

        fld     dword coef(8,0)
        fmul    dword a(0)
        fld     dword coef(8,1)
        fmul    dword a(1)
        fld     dword coef(8,2)     
        fmul    dword a(2)          
        fld     dword coef(8,3)     
        fmul    dword a(3)          
        fxch    st3                 
        faddp   st1,st0             
        fxch    st2
        faddp   st1,st0
        fld     dword coef(8,0)
        fmul    dword b(0)
        fxch    st1
        faddp   st2,st0                     
        fld     dword coef(8,1)
        fmul    dword b(1)                  
        fxch    st2
        fadd    dword a(4)                  
        fld     dword coef(8,2)
        fmul    dword b(2)
        fld     dword coef(8,3)
        fmul    dword b(3)                  
        fxch    st3
        faddp   st1,st0                     
        fxch    st3
        faddp   st2,st0                     
        fxch    st4
        fsubr   st3                         
        fxch    st2
        faddp   st1,st0                     
        fxch    st3                         
        fsub    st1                         
        fxch    st1
        fstp    dword f(15)                 
        fxch    st2     
        fadd    dword b(4)                  
        fxch    st2
        fst     dword f(16)                 
        fxch    st2                         
        fsubrp  st1,st0                     
        fsubrp  st1,st0
        fstp    dword f(17)                 
endproc

%undef    a
%undef    b
%undef    mdct18w
%undef    mdct18w2
%undef    coef
%undef    f

;/*
; * imdct18 ASM Version
; */
proc imdct18_p5 ;// PROC f[]
%$f     arg     4
        pushd   edi
        mov     edi, [sp(%$f)]
        call    _imdct18_inner_p5
        popd    edi
endproc

%idefine    a(p,i)      [esp+((p)*6+i)*4]
%idefine    mdct6_3v(p) [_mdct6_3v+(p)*4]
%idefine    mdct6_3v2(p) [_mdct6_3v2+(p)*4]
%idefine    f(p)        [edi+(p)*4]
%idefine    c(p,i)      [edi+((p)*6+(i))*4]

proc imdct6_3_inner_p5
; void imdct6_3_p5(float f[]) ̉
;   input   edi     f[]
;   uses    none
;/* Unroll the loop because it is a known-value count */
%$tab_a local   18*4
        alloc
%assign p 0
%rep 3
        fld     dword f(p+0)
        fmul    dword mdct6_3v(0)
        fld     dword f(p+15)
        fmul    dword mdct6_3v(5)
        fld     dword f(p+3)
        fmul    dword mdct6_3v(1)   ; g1[1] g2[0] g1[0]
        fld     st2
        fadd    st2                 ; a[0] g1[1] g2[0] g1[0]
        fxch    st3
        fsubrp  st2,st0             ; g1[1] g1[0]-g2[0] a[0]
        fld     dword f(p+12)
        fmul    dword mdct6_3v(4)   ; g2[1] g1[1] g1[0]-g2[0] a[0]
        fld     st1                 ; g1[1] g2[1] g1[1] g1[0]-g2[0] a[0]
        fxch    st3
        fmul    dword mdct6_3v2(0)  ; a[3] g2[1] g1[1] g1[1] a[0]
        fxch    st2
        fadd    st1                 ; a[1] g2[1] a[3]  g1[1] a[0]
        fxch    st3
        fsubrp  st1,st0             ; g1[1]-g2[1] a[3] a[1] a[0]
        fld     dword f(p+6)
        fmul    dword mdct6_3v(2)
        fld     dword f(p+9)
        fmul    dword mdct6_3v(3)   ; g2[2] g1[2] g1[1]-g2[1] a[3] a[1] a[0]
        fxch    st2
        fmul    dword mdct6_3v2(1)  ; a[4] g1[2] g2[2] a[3] a[1] a[0]
        fld     st1
        fadd    st3                 ; a[2] a[4] g1[2] g2[2] a[3] a[1] a[0]
        fxch    st2
        fsubrp  st3,st0             ; a[4] a[2] g1[2]-g2[2] a[3] a[1] a[0]
        fxch    st5
        fstp    dword a(p,0)        ; a[2] g1[2]-g2[2] a[3] a[1] a[4]
        fxch    st3
        fstp    dword a(p,1)        ; g1[2]-g2[2] a[3] a[2] a[4]
        fmul    dword mdct6_3v2(2)  ; a[5] a[3] a[2] a[4]
        fxch    st3                 ; a[4] a[3] a[2] a[5]
        fstp    dword a(p,4)        
        fstp    dword a(p,3)        
        fstp    dword a(p,2)        
        fstp    dword a(p,5)        
%assign p p+1
%endrep

;/* Unroll the loop because it is a known-value count */
%assign p 0
%rep 3
        fld     dword a(p,0)
        fadd    dword a(p,2)
        fld     dword a(p,3)
        fadd    dword a(p,5)    ; b02 a02
        fld     dword a(p,1)
        fadd    st2             ; c0 b02 a02
        fld     dword a(p,4)
        fadd    st2             ; c1' c0 b02 a02
        fld     dword a(p,0)
        fsub    dword a(p,2)
        fld     dword a(p,3)
        fsub    dword a(p,5)    ; a3-a5 a0-a2 c1' c0 b02 a02
        fxch    st3
        fst     dword c(p,0)    ; c0 a0-a2 c1' a3-a5 b02 a02
        fxch    st1             
        fmul    dword [_coef87] ; c2' c0 c1' a3-a5 b02 a02
        fxch    st1
        fsubr   st2             ; c1 c2' c1' a3-a5 b02 a02
        fxch    st3
        fmul    dword [_coef87] ; c3'' c2' c1' c1 b02 a02
        fxch    st3
        fst     dword c(p,1)    ; c1 c2' c1' c3'' b02 a02
        fsubp   st1,st0         ; c2 c1' c3'' b02 a02
        fxch    st4
        fsub    dword a(p,1)    ; a02-a1 c1' c3'' b02 c2
        fxch    st2 
        fsubrp  st1,st0         ; c3' a02-a1 b02 c2
        fxch    st2
        fsub    dword a(p,4)    ; b02-a4 a02-a1 c3' c2
        fxch    st3
        fst     dword c(p,2)    ; c2 a02-a1 c3' b02-a4
        fxch    st1
        fsub    dword a(p,1)    ; c4' c2 c3' b02-a4
        fxch    st1
        fsubr   st2             ; c3 c4' c3' b02-a4
        fxch    st3
        fsub    dword a(p,4)    ; c5'' c4' c3' c3
        fxch    st3
        fst     dword c(p,3)    ; c3 c4' c3' c5''
        fsubp   st1,st0         ; c4 c3' c5''
        fxch    st2             
        fsubrp  st1,st0         ; c5' c4
        fxch    st1
        fst     dword c(p,4)    ; c4 c5'
        fsubp   st1,st0         ; c5
        fstp    dword c(p,5)    ; -
%assign p p+1
%endrep
endproc

%undef    a
%undef    mdct6_3v
%undef    mdct6_3v2
%undef    f
%undef    c

;/*
; * imdct6_3 ASM Version
; */
proc imdct6_3_p5 ;// PROC f[]
%$f     arg     4
        pushd   edi
        mov     edi, [sp(%$f)]
        call    _imdct6_3_inner_p5
        popd    edi
endproc

%idefine    win(j)  [ebx+(j)*4]
%idefine    x(j)    [edi+(j)*4]
%idefine    x0(j)   [esi+(j)*4]
%idefine    y(j,i)  [ebp+(j)*128+(i)*4]

;/*
; * hybrid ASM Version
; */
proc hybrid_p5 ;// xin[] xprev[] y[18][32] btype  nlong  ntot   nprev
%$xin   arg     4
%$xprev arg     4
%$yout  arg     4
%$btype arg     4
%$nlong arg     4
%$ntot  arg     4
%$nprev arg     4

        pushd   ebx, esi, edi, ebp

        mov     ebx, [sp(%$btype)]
        xor     ecx, ecx        ; loop counter i
        mov     eax, WINSIZE
        cmp     ebx, 2
        jne    .SkipBTYPE
        mov     ebx, ecx
      .SkipBTYPE:
        mul     ebx
        lea     ebx, [_win+eax] ; ebx is win[btype]

        mov     edi, [sp(%$xin)]    ; edi is x
        mov     esi, [sp(%$xprev)]  ; esi is x0
        mov     ebp, [sp(%$yout)]   ; ebp is y

        mov     eax, [sp(%$nlong)]
        add     eax, 17
        div18                   ; edx is n
        cmp     ecx, edx
        jge     near .ExitLongBlockLoop

        ;/* Long block loop */
        align 4
      .LongBlockLoop:
        call _imdct18_inner_p5

        ;/* Unrool first J-controlled loop */
%assign j 0
%assign k 1
%assign l 2
%rep 3
        fld     dword win(j)
        fmul    dword x(9+j)
        fld     dword win(k)
        fmul    dword x(9+k)
        fld     dword win(l)
        fmul    dword x(9+l)    
        fld     dword win(9+j)
        fmul    dword x(17-j)
        fld     dword win(9+k)
        fmul    dword x(17-k)
        fld     dword win(9+l)
        fmul    dword x(17-l)   ; l2 k2 j2 l1 k1 j1

        fxch    st5
        fadd    dword x0(j)     ; j1 k2 j2 l1 k1 l2
        fxch    st4             
        fadd    dword x0(k)     ; k1 k2 j2 l1 j1 l2
        fxch    st3
        fadd    dword x0(l)     ; l1 k2 j2 k1 j1 l2
        fxch    st2             
        fadd    dword x0(9+j)   ; j2 k2 l1 k1 j1 l2
        fxch    st1             
        fadd    dword x0(9+k)   ; k2 j2 l1 k1 j1 l2
        fxch    st5             
        fadd    dword x0(9+l)   ; l2 j2 l1 k1 j1 k2

        fxch    st4
        fstp    dword y(j,ecx)  ; j2 l1 k1 l2 k2
        fxch    st2
        fstp    dword y(k,ecx)  ; l1 j2 l2 k2
        fstp    dword y(l,ecx)  ; j2 l2 k2
        fstp    dword y(9+j,ecx)
        fxch    st1
        fstp    dword y(9+k,ecx)
        fstp    dword y(9+l,ecx)
%assign j j+3
%assign k k+3
%assign l l+3
%endrep
        ;/* Unrool second J-controlled loop */
%assign j 0
%rep 4
        fld     dword x(8-j)
        fld     dword x(j)
        fld     dword win(18+j)
        fmul    st2                     ; x[j] xa xb
        fld     dword win(26-j)     
        fmul    st2                     ; x[8-j] x[j] xa xb
        fxch    st3
        fmul    dword win(35-j)         ; x[17-j] x[j] xa x[8-j]
        fxch    st1
        fstp    dword x(j)              ; x[17-j] xa x[8-j]
        fxch    st1
        fmul    dword win(27+j)         ; x[9+j] x[17-j] x[8-j]
        fxch    st2                     ; x[8-j] x[17-j] x[9+j]
        fstp    dword x(8-j)                
        fstp    dword x(17-j)               
        fstp    dword x(9+j)                
%assign j j+1
%endrep

%assign j 4
        fld     dword x(j)
        fmul    dword win(18+j)
        fld     dword x(j)
        fmul    dword win(27+j)
        fxch    st1
        fstp    dword x(j)
        fstp    dword x(9+j)

        add    edi,18*4                ;/* Update x */
        add    esi,18*4                ;/* Update x0 */

        inc    ecx                     ;/* Increment counter */
        cmp    ecx,edx
        jl     near .LongBlockLoop
      .ExitLongBlockLoop:

        mov     eax, [sp(%$ntot)]
        add    eax,17
        div18

        ;/* First check */
        cmp    ecx,edx
        jge    near .ExitShortBlockLoop

        ;/* Short block loop */
        mov    ebx,_win+(WINSIZE*2)    ;/* address of win[2] is in ebx */
        align 4
      .ShortBlockLoop:
        call _imdct6_3_inner_p5

        ;/* First unrolled loop */
%assign j 0
%assign k 1
%assign l 2
        fld     dword x(3+j)
        fmul    dword win(j)
        fld     dword x(3+k)
        fmul    dword win(k)
        fld     dword x(3+l)
        fmul    dword win(l)    ; l k j
        fxch    st2
        fadd    dword x0(6+j)   ; j k l
        fxch    st1
        fadd    dword x0(6+k)   ; k j l
        fxch    st2
        fadd    dword x0(6+l)   ; l j k
        fld     dword x0(j)
        fstp    dword y(j,ecx)
        fxch    st1
        fstp    dword y(6+j,ecx); l k
        fxch    st1
        fstp    dword y(6+k,ecx); l
        fstp    dword y(6+l,ecx); 

        fld     dword x(5-j)
        fmul    dword win(3+j)  
        fld     dword x(5-k)
        fmul    dword win(3+k)
        fld     dword x(5-l)
        fmul    dword win(3+l)  ; l k j
        fxch    st2
        fadd    dword x0(9+j)
        fxch    st1
        fadd    dword x0(9+k)
        fxch    st2
        fadd    dword x0(9+l)
        fld     dword x0(3+j)
        fstp    dword y(3+j,ecx)
        fxch    st1     
        fstp    dword y(9+j,ecx)
        fxch    st1
        fstp    dword y(9+k,ecx)
        fstp    dword y(9+l,ecx)

        fld     dword x(2-j)
        fmul    dword win(6+j)
        fld     dword x(9+j)
        fmul    dword win(j)
        fld     dword x(2-k)
        fmul    dword win(6+k)
        fld     dword x(9+k)
        fmul    dword win(k)
        fld     dword x(2-l)
        fmul    dword win(6+l)
        fld     dword x(9+l)
        fmul    dword win(l)    ; l l k k j j
        fxch    st5
        faddp   st4, st0        ; l k k j l
        fxch    st2
        faddp   st1, st0        ; k l j l
        fxch    st1
        faddp   st3, st0        ; k j l
        fld     dword x0(k)
        fstp    dword y(k,ecx)
        fxch    st1
        fadd    dword x0(12+j)  ; j k l
        fxch    st1 
        fadd    dword x0(12+k)  ; k j l
        fxch    st2
        fadd    dword x0(12+l)  ; l j k
        fld     dword x0(3+k)
        fstp    dword y(3+k,ecx)
        fxch    st1
        fstp    dword y(12+j,ecx); l k
        fxch    st1
        fstp    dword y(12+k,ecx)
        fstp    dword y(12+l,ecx)

        fld     dword x(j)
        fmul    dword win(9+j)
        fld     dword x(11-j)
        fmul    dword win(3+j)
        fld     dword x(k)
        fmul    dword win(9+k)
        fld     dword x(11-k)
        fmul    dword win(3+k)
        fld     dword x(l)
        fmul    dword win(9+l)
        fld     dword x(11-l)
        fmul    dword win(3+l)
        fxch    st5
        faddp   st4,st0
        fxch    st2
        faddp   st1,st0
        fxch    st1
        faddp   st3,st0
        fld     dword x0(l)
        fstp    dword y(l,ecx)
        fxch    st1
        fadd    dword x0(15+j)
        fxch    st1
        fadd    dword x0(15+k)
        fxch    st2
        fadd    dword x0(15+l)
        fld     dword x0(3+l)
        fstp    dword y(3+l,ecx)
        fxch    st1
        fstp    dword y(15+j,ecx)
        fxch    st1
        fstp    dword y(15+k,ecx)
        fstp    dword y(15+l,ecx)


        ;/* Second unrolled loop */
%assign j 0
%rep 3
        fld     dword win(6+j)
        fmul    dword x(8-j)
        fld     dword win(j)
        fmul    dword x(15+j)
        fld     dword win(9+j)
        fmul    dword x(6+j)
        fld     dword win(3+j)
        fmul    dword x(17-j)
        fxch    st3
        faddp   st2,st0
        faddp   st2,st0
        fstp    dword x(j)
        fstp    dword x(3+j)
%assign j j+1
%endrep

        ;/* Third unrolled loop */
%assign j 0
%rep 3
        fld     dword win(6+j)
        fmul    dword x(14-j)
        fld     dword win(9+j)
        fmul    dword x(12+j)
        fxch    st1
        fstp    dword x(6+j)
        fstp    dword x(9+j)
%assign j j+1
%endrep

        ;/* Fourth unrolled loop */
        fldz
%assign j 0
%rep 5
        fst    dword x(12+j)
%assign j j+1
%endrep
        fstp   dword x(17)

        add    edi,18*4                ;/* Update x */
        add    esi,18*4                ;/* Update x0 */

        inc    ecx
        cmp    ecx,edx
        jl     near .ShortBlockLoop
      .ExitShortBlockLoop:

        mov     eax, [sp(%$nprev)]
        add    eax,17
        div18

        ;/* First check */
        cmp    ecx,edx
        jge    near .ExitLastBlockLoop
        ;/* Short block loop */
        align 4
      .LastBlockLoop:

%assign j 0
%rep 18
        mov    ebx,[esi+j*4]
        mov    [ebp+ecx*4+j*128],ebx
%assign j j+1
%endrep
        add    esi,18*4

        inc    ecx
        cmp    ecx,edx
        jl     near .LastBlockLoop
      .ExitLastBlockLoop:

        ;/* Compute return value */
        mov    eax,18
        mul    ecx
        mov     edx, dword [_band_limit_nsb]
        cmp     ecx, edx
        jge    near .SkipFinalClear
      .FinalClear:
        xor     edi, edi
%assign j 0
%rep 18
        mov    dword [ebp+ecx*4+j*128],edi
%assign j j+1
%endrep
        inc    ecx
        cmp    ecx, edx
        jl     near .FinalClear

      .SkipFinalClear:

        popd    ebx, esi, edi, ebp
endproc

%undef  win
%undef  x
%undef  x0
%undef  y

end
