{
  decode ̃`FbN

    w肵fBNgɂ *.mp3  *.wav ̗t@C
    A*.mp3 fR[hāA*.wav Ƃ̈Ⴂ`FbNB
    `FbŇʂ Result ɕ\B
    ͂܂܂

  g
    AZuŕςȂƂĂȂł *.wav ĂāAAZu
    ̏ȂǁAfR[hɉeȕύXAŃ`Fb
    NĂ

  Ȃ̂TvɓƂ̂́Aƃ}VȃfR[h`FbNȂ
  ė~ł
}

unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ComCtrls, ExtCtrls, FileCtrl, MP3Plyr;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ListView1: TListView;
    Button1: TButton;
    Panel2: TPanel;
    Splitter1: TSplitter;
    DirectoryListBox1: TDirectoryListBox;
    Panel3: TPanel;
    DriveComboBox1: TDriveComboBox;
    MP3Player1: TMP3Player;
    StatusBar1: TStatusBar;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MP3Player1EndPlay(Sender: TObject;
      Reason: TMP3EndPlayReason);
    procedure MP3Player1ChangeStatus(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
  private
    { Private 錾 }
    FPlayingIdx: Integer;
    FStopFlag: Boolean;

    procedure StartPlay;
    function CheckValidate(WaveFile1, WaveFile2: TFileName): String;
  public
    { Public 錾 }
  end;

  TWaveHeader = packed record
    MainChunk: array[0..3] of Char;
    FileSize: Integer;
    FormType: array[0..3] of Char;
    SubChunk: array[0..3] of Char;
    ChunkLen: Integer;
    Format: SmallInt;
    Modus: SmallInt;
    SampleRate: Integer;
    BitRate: Integer;
    BlockSize: SmallInt;
    SampleDepth: SmallInt;
    DataChunk: array[0..3] of Char;
    DataSize: Integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FPlayingIdx := -1;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  searchRec: TSearchRec;
  found: Boolean;
begin
  FStopFlag := False;
  ListView1.Items.Clear;
  found := FindFirst(
    DirectoryListBox1.Directory+'\*.mp*',
    faAnyFile-faDirectory,
    searchRec
  ) = 0;
  try
    while found do begin
      if FileExists(DirectoryListBox1.Directory+'\'+ChangeFileExt(searchRec.Name, '.wav')) then begin
        with ListView1.Items.Add do begin
          Caption := searchRec.Name;
          SubItems.Add('?');
          SubItems.Add(DirectoryListBox1.Directory+'\'+searchRec.Name);
          SubItems.Add(DirectoryListBox1.Directory+'\'+ChangeFileExt(searchRec.Name, '.wav'));
          SubItems.Add(DirectoryListBox1.Directory+'\'+ChangeFileExt(searchRec.Name, '.test.wav'));
        end;
      end;
      found := FindNext(searchRec) = 0;
    end;
  finally
    //  Delphi3.1 ܂ł́AFindFirst s FindClose ĂԂƁA
    //  邱ƂAD4 ŏCĂ
    FindClose(searchRec);
  end;

  FPlayingIdx := 0;
  StartPlay;
end;

procedure TForm1.MP3Player1EndPlay(Sender: TObject;
  Reason: TMP3EndPlayReason);
var
  res: String;
begin
  case Reason of
    merSuccessful: begin
      res := CheckValidate(ListView1.Items[FPlayingIdx].SubItems[2],
        ListView1.Items[FPlayingIdx].SubItems[3]);
    end;
    merStoped: begin
      res := 'stoped';
    end;
    merFailure: begin
      res := 'error';
    end;
  end;
  ListView1.Items[FPlayingIdx].SubItems[0] := res;
  Inc(FPlayingIdx);
  StartPlay;
end;

procedure TForm1.MP3Player1ChangeStatus(Sender: TObject);
var
  statusStr: String;
begin
  statusStr := '';
  if not MP3Player1.IsOpen then begin
    statusStr := 'Closed';
  end
  else begin
    case MP3Player1.Status of
      mstPlay: begin
        statusStr := 'Playing';
      end;
      mstPause: begin
        statusStr := 'Pausing';
      end;
      mstStop: begin
        statusStr := 'Stoped';
      end;
    end;
  end;
  StatusBar1.SimpleText := statusStr;
end;

type
  TSample = packed record
    Right, Left: SmallInt;
  end;

function TForm1.CheckValidate(WaveFile1, WaveFile2: TFileName): String;
var
  stream1, stream2: TFileStream;
  sample1, sample2: TSample;
  sampleCount: Integer;
  leftDiff: Extended;
  rightDiff: Extended;
  leftDiffSum: Extended;
  rightDiffSum: Extended;
  leftDiffMax: Extended;
  rightDiffMax: Extended;
begin
  Result := '';
  stream1 := nil;
  stream2 := nil;
  try
    stream1 := TFileStream.Create(WaveFile1, fmOpenRead);
    stream2 := TFileStream.Create(WaveFile2, fmOpenRead);

    StatusBar1.SimpleText := 'Checking Validate';
    StatusBar1.Update;

    if stream1.Size <> stream2.Size then begin
      Result := 'unmatch file size';
      Exit;
    end;

    stream1.Position := SizeOf(TWaveHeader);
    stream2.Position := SizeOf(TWaveHeader);
    sampleCount := 0;
    leftDiffSum := 0.0;
    rightDiffSum := 0.0;
    leftDiffMax := 0.0;
    rightDiffMax := 0.0;

    while stream1.Position+SizeOf(TSample) < stream1.Size do begin
      stream1.ReadBuffer(sample1, SizeOf(sample1));
      stream2.ReadBuffer(sample2, SizeOf(sample2));

      leftDiff := Abs(1.0*sample1.Left-1.0*sample2.Left);
      rightDiff := Abs(1.0*sample1.Right-1.0*sample2.Right);
      if leftDiffMax < leftDiff then begin
        leftDiffMax := leftDiff;
      end;
      if rightDiffMax < rightDiff then begin
        rightDiffMax := rightDiff;
      end;

      leftDiffSum := leftDiffSum+leftDiff;
      rightDiffSum := rightDiffSum+rightDiff;
      Inc(sampleCount);
      if sampleCount mod 1000 = 0 then begin
        StatusBar1.SimpleText :=
          IntToStr(stream1.Position)+
          '/'+IntToStr(+stream1.Size)+
          '('+FloatToStr(leftDiffSum/sampleCount)+
          ','+FloatToStr(rightDiffSum/sampleCount)+')'+
          ':('+FloatToStr(leftDiffMax)+
          ','+FloatToStr(rightDiffMax)+')';
        StatusBar1.Update;
        Application.ProcessMessages;
        if FStopFlag then begin
          Break;
        end;
      end;
    end;

    Result := FloatToStr((leftDiffSum+rightDiffSum)/sampleCount/2);
  finally
    stream1.Free;
    stream2.Free;
  end;


end;

procedure TForm1.StartPlay;
begin
  while not FStopFlag and (FPlayingIdx < ListView1.Items.Count) do begin
    try
      with MP3Player1 do begin
        FileName := ListView1.Items[FPlayingIdx].SubItems[1];
        PlayToFile(ListView1.Items[FPlayingIdx].SubItems[3]);
      end;
    except
      ListView1.Items[FPlayingIdx].SubItems[0] := 'Error';
      Inc(FPlayingIdx);
      Continue;
    end;
    Break;
  end;

  if FStopFlag or not(FPlayingIdx < ListView1.Items.Count) then begin
    MP3Player1.Close;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FStopFlag := True;
end;

procedure TForm1.DriveComboBox1Change(Sender: TObject);
var
  searchRec: TSearchRec;
  driveExists: Boolean;
begin
  driveExists := FindFirst(DriveComboBox1.Drive+':\*.*', faAnyFile, searchRec) = 0;
  try
    if driveExists then begin
      DirectoryListBox1.Drive := DriveComboBox1.Drive;
    end;
  finally
    FindClose(searchRec);
  end;
end;

end.
