{
  pIɊȒPȃvC[

  vCXg悤ɂΎgEEE^^;;
}

unit Unit3;

interface

uses
  Windows, Messages, SysUtils,  Forms,
  MP3Plyr, Buttons, ShellAPI, ComCtrls,
  ExtCtrls, Controls, Classes, Dialogs, StdCtrls;


type
  TForm1 = class(TForm)
    OpenDialog: TOpenDialog;
    MP3Player: TMP3Player;
    PlayBtn: TSpeedButton;
    StopBtn: TSpeedButton;
    PauseBtn: TSpeedButton;
    OpenBtn: TSpeedButton;
    RepeatBtn: TSpeedButton;
    Volume: TTrackBar;
    TitleTimer: TTimer;
    TimeProgress: TProgressBar;
    Balance: TTrackBar;
    EqualizerBtn: TSpeedButton;
    FileOutBtn: TSpeedButton;
    InfoBtn: TSpeedButton;
    SaveDialog: TSaveDialog;
    EQ0: TTrackBar;
    EQ1: TTrackBar;
    EQ2: TTrackBar;
    EQ3: TTrackBar;
    EQ4: TTrackBar;
    EQ5: TTrackBar;
    procedure VolumeChange(Sender: TObject);
    procedure TitleTimerTimer(Sender: TObject);
    procedure MP3PlayerChangePosition(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TimeProgressMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BalanceChange(Sender: TObject);
    procedure EQ0Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MP3PlayerChangeStatus(Sender: TObject);
    procedure MP3PlayerEndPlay(Sender: TObject; Reason: TMP3EndPlayReason);
    procedure InfoBtnClick(Sender: TObject);
    procedure EqualizerBtnClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure PauseBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure FileOutBtnClick(Sender: TObject);
  private
    FTimeFormat: String;
    FSongTitle: String;
    FTitlePos: Integer;
    FFirstShowDone: Boolean;
    procedure WMDropFile(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure OpenNextFile;
    function RoundFreq(N: Integer): Integer;
  protected
  public
    FFileNames: TStrings;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.VolumeChange(Sender: TObject);
begin
  MP3Player.Volume := 100-Volume.Position;
  Volume.Hint := 'Volume:'+IntToStr(MP3Player.Volume);
end;

procedure TForm1.TitleTimerTimer(Sender: TObject);
var
  idx: Integer;
  p: PChar;
begin
  if FSongTitle <> '' then begin
    if FTitlePos = 0 then begin
      Caption := FSongTitle;
      Inc(FTitlePos);
    end
    else begin
      p := PChar(FSongTitle);
      for idx := 0 to FTitlePos-1 do begin
        p := CharNext(p);
      end;
      Caption := p;
      if p[0] = #0 then begin
        FTitlePos := 0;
      end
      else begin
        Inc(FTitlePos);
      end;
    end;
  end;
end;

procedure TForm1.MP3PlayerChangePosition(Sender: TObject);
var
  newHint: String;
  newPos: Integer;
begin
  newPos := MP3Player.Position;
  if (0 < MP3Player.Length) and (0 < newPos) then begin
    TimeProgress.Max := MP3Player.Length;
    TimeProgress.Position := newPos;
  end
  else begin
    TimeProgress.Position := 0;
  end;
  newHint := FormatDateTime(FTimeFormat, newPos*0.001/3600.0/24.0);
  if 0 < MP3Player.Length then begin
    newHint := newHint+'/'+
      FormatDateTime(FTimeFormat, MP3Player.Length*0.001/3600.0/24.0);
  end;
  TimeProgress.Hint := newHint;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  paramIdx: Integer;
  eqBandIdx: Integer;
begin
  Caption := ChangeFileExt(ExtractFileName(ParamStr(0)), '');

  DragAcceptFiles(Handle, True);

  FFileNames := TStringList.Create;

  FTimeFormat := 'h:nn:ss';

  TimeProgress.Hint := FormatDateTime(FTimeFormat, 0.0);

  for paramIdx := 1 to ParamCount do begin
    FFileNames.Add(ParamStr(paramIdx));
  end;

  for eqBandIdx := 0 to 5 do begin
    (FindComponent('EQ'+IntToStr(eqBandIdx)) as TTrackBar).Hint :=
      IntToStr(RoundFreq(MP3Player.EqualizerFreq[eqBandIdx]))+'Hz:0';
  end;

  Volume.Position := 100-MP3Player.Volume;
end;

procedure TForm1.WMDropFile(var Msg: TWMDropFiles);
var
  fileName: array[0..255] of Char;
  count, idx: Integer;
begin
  inherited;

  try
    count := DragQueryFile(Msg.Drop,  $FFFFFFFF, fileName, SizeOf(fileName));
    FFileNames.Clear;
    for idx := 0 to count-1 do begin
      DragQueryFile(Msg.Drop, idx, fileName, SizeOf(fileName));
      FFileNames.Add(fileName);
    end;
  except
    DragFinish(Msg.Drop);
  end;

  OpenNextFile;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FFileNames.Free;
end;

procedure TForm1.TimeProgressMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  len: Int64;
begin
  len := Mp3Player.Length;
  if 0 < len then begin
    MP3Player.Seek(len*X div TimeProgress.Width);
  end;
end;

procedure TForm1.BalanceChange(Sender: TObject);
begin
  MP3Player.VolBalance := Balance.Position;
  Balance.Hint := 'Balance:'+IntToStr(MP3Player.VolBalance);
end;

procedure TForm1.EQ0Change(Sender: TObject);
var
  newValue: Integer;
  eqBar: TTrackBar;
begin
  eqBar := Sender as TTrackBar;
  newValue := -eqBar.Position*5;
  MP3Player.Equalizer[eqBar.Tag] := newValue;
  eqBar.Hint := IntToStr(RoundFreq(MP3Player.EqualizerFreq[eqBar.Tag]))+'Hz:'+
    IntToStr(-eqBar.Position);
end;

procedure TForm1.OpenNextFile;
var
  newFileName: String;
begin
  while 0 < FFileNames.Count do begin
    newFileName := FFileNames[0];
    FFileNames.Delete(0);
    try
      with MP3Player do begin
        Close;
        FileName := newFileName;
      end;
    except
      Continue;
    end;
    if RepeatBtn.Enabled and RepeatBtn.Down then begin
      FFileNames.Add(newFileName);
    end;
    Exit;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if not FFirstShowDone then begin
    Volume.Position := 100-MP3Player.Volume;

    MP3PlayerChangeStatus(MP3Player);

    OpenNextFile;

    FFirstShowDone := True;
  end;
end;

procedure TForm1.MP3PlayerChangeStatus(Sender: TObject);
var
  newCaption: String;
begin
  FSongTitle := '';
  if Mp3Player.RiffInfos.Values['INAM'] <> '' then begin
    FSongTitle := Mp3Player.RiffInfos.Values['INAM'];
  end
  else if MP3Player.Title <> '' then begin
    FSongTitle := MP3Player.Title;
  end
  else if MP3Player.FileName <> '' then begin
    FSongTitle := ExtractFileName(MP3Player.FileName);
  end;
  newCaption := ChangeFileExt(ExtractFileName(Application.ExeName), '');
  if FSongTitle <> '' then begin
    newCaption := FSongTitle+':'+newCaption;
  end
  else begin
    Caption := newCaption;
  end;
  with MP3Player do begin
    OpenBtn.Enabled := mcbCanOpen in Capabilities;
    StopBtn.Enabled := mcbCanStop in Capabilities;
    PlayBtn.Enabled := mcbCanPlay in Capabilities;
    PauseBtn.Enabled := [mcbCanPause, mcbCanUnPause] * Capabilities <> [];
    PauseBtn.Down := mcbCanUnpause in Capabilities;
    if PauseBtn.Down then begin
      PauseBtn.Hint := 'Unpause';
    end
    else begin
      PauseBtn.Hint := 'Pause';
    end;
    FileOutBtn.Enabled := mcbCanPlayToFile in Capabilities;
    EqualizerBtn.Down := EqualizerEnabled;
  end;
  Hint := newCaption;
  Application.Title := newCaption;
  TitleTimer.Enabled := MP3Player.Status = mstPlay;
  TimeProgress.Enabled := Mp3Player.IsOpen;
  InfoBtn.Enabled := Mp3Player.IsOpen;
end;

procedure TForm1.MP3PlayerEndPlay(Sender: TObject;
  Reason: TMP3EndPlayReason);
begin
  if Reason <> merSuccessful then begin
    Exit;
  end;

  if 1 < FFileNames.Count then begin
    OpenNextFile;
  end
  else begin
    if RepeatBtn.Enabled and RepeatBtn.Down then begin
      MP3Player.Play;
    end;
  end;
end;

procedure TForm1.InfoBtnClick(Sender: TObject);
var
  infos: String;
  riffIdx: Integer;
  id3Idx: Integer;

  procedure AddInfos(InfoName, Info: String);
  begin
    if Info <> '' then begin
      if infos <> '' then begin
        infos := infos+#10;
      end;
      infos := infos+infoName+':'+info;
    end;
  end;

begin
  if not MP3Player.IsOpen then begin
    Exit;
  end;

  infos := '';
  with MP3Player do begin
    AddInfos('Title', Title);
    AddInfos('Artist', Artist);
    AddInfos('Album', Album);
    AddInfos('Year', Year);
    AddInfos('Comment', Comment);
    AddInfos('Track', Track);
    AddInfos('Genre', Genre);
    infos := infos+#10;
    if 0 < ID3V1Infos.Count then begin
      for id3Idx := 0 to RiffInfos.Count-1 do begin
        AddInfos(ID3V1Infos.Names[id3Idx], ID3V1Infos.Values[ID3V1Infos.Names[id3Idx]] );
      end;
      infos := infos+#10;
    end;
    if 0 < RIFFInfos.Count then begin
      for riffIdx := 0 to RiffInfos.Count-1 do begin
        AddInfos(RiffInfos.Names[riffIdx], RiffInfos.Values[RiffInfos.Names[riffIdx]] );
      end;
      infos := infos+#10;
    end;
    case Version of
    1..2: begin
        AddInfos('MPEG', IntToStr(Version));
      end;
    3: begin
        AddInfos('MPEG', '2.5');
      end;
    end;
    AddInfos('Layer', IntToStr(Layer));
    if 0 < BitRate then begin
      AddInfos('BitRate', IntToStr(BitRate));
    end
    else begin
      AddInfos('BitRate', 'VBR');
    end;
    if 0 < SamplingRate then begin
      AddInfos('Sampling Rate', IntToStr(SamplingRate));
    end;
    case Channels of
    1: begin
        AddInfos('Channels', 'Mono');
      end;
    2: begin
        AddInfos('Channels', 'Streo');
      end;
    end;
  end;

  Application.MessageBox(PChar(infos), PChar(FSongTitle), MB_OK+MB_ICONINFORMATION);
end;

procedure TForm1.EqualizerBtnClick(Sender: TObject);
var
  eqBandIdx: Integer;
  eqBar: TTrackBar;
begin
  with MP3Player do begin
    EqualizerEnabled := EqualizerBtn.Down;
    if EqualizerEnabled then begin
      for eqBandIdx := 0 to 5 do begin
        eqBar := Self.FindComponent('EQ'+IntToStr(eqBandIdx)) as TTrackBar;
        with eqBar do begin
          Left := EqualizerBtn.Left+EqualizerBtn.Width+12*eqBandIdx;
          Visible := True;
        end;
      end;
    end
    else begin
      for eqBandIdx := 0 to 5 do begin
        eqBar := Self.FindComponent('EQ'+IntToStr(eqBandIdx)) as TTrackBar;
        with eqBar do begin
          Visible := False;
          Left := 0;
        end;
      end;
    end;
  end;
end;

procedure TForm1.PlayBtnClick(Sender: TObject);
begin
  with MP3Player do begin
    if mcbCanPlay in Capabilities then begin
      FTitlePos := 0;
      Play;
    end;
  end;
end;

procedure TForm1.PauseBtnClick(Sender: TObject);
begin
  with MP3Player do begin
    case Status of
    mstPlay: begin
        Pause;
      end;
    mstPause: begin
        Unpause;
      end;
    end;
  end;
end;

procedure TForm1.StopBtnClick(Sender: TObject);
begin
  MP3Player.Stop;
end;

procedure TForm1.OpenBtnClick(Sender: TObject);
begin
  with OpenDialog do begin
    if Execute then begin
      FTitlePos := 0;
      MP3Player.Close;
      Self.FFileNames.Assign(Files);
      Self.OpenNextFile;
    end;
  end;
end;

procedure TForm1.FileOutBtnClick(Sender: TObject);
begin
  with SaveDialog do begin
    if Mp3Player.IsOpen then begin
      FileName := ChangeFileExt(OpenDialog.FileName, '.wav');
    end;
    if Execute then begin
      MP3Player.PlayToFile(FileName);
    end;
  end;
end;

function TForm1.RoundFreq(N: Integer): Integer;
begin
  case N of
    1..19: Result := N;
    20..49: Result := (N+1) div 2 * 2;
    50..199: Result := (N+5) div 10 * 10;
    200..499: Result := (N+10) div 20 * 20;
    500..1999: Result := (N+50) div 100 * 100;
    2000..4999: Result := (N+100) div 200 * 200;
    5000..MaxInt: Result := (N+500) div 1000 * 1000;
  else
    Result := N;
  end
end;

end.
